"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../models/sharedService");
var http_1 = require("@angular/http");
var ButtonComponent = /** @class */ (function (_super) {
    __extends(ButtonComponent, _super);
    function ButtonComponent(_translateService, _http, _sharedService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._sharedService = _sharedService;
        _this.classCss = '';
        _this.css = 'sbm-btn-default';
        sbmButtonComponent.push(_this);
        return _this;
    }
    Object.defineProperty(ButtonComponent.prototype, "columns", {
        set: function (value) {
            if (value) {
                this._columns = "col l" + value + " s12 m12 crud-form-dynamic";
            }
            else {
                this._columns = 'col l12 m12 s12 crud-form-dynamic';
            }
            this.fullWidth = true;
            this.classCss = this._columns;
        },
        enumerable: true,
        configurable: true
    });
    ButtonComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
    };
    ButtonComponent.prototype.itemClicado = function ($event) {
        this._onClick.emit($event);
        if (this.onClick != '') {
            window[this.onClick](true);
        }
    };
    ButtonComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-button',
                    template: require('./button.component.html'),

                    styles: [require('./button.component.css')],
                    host: {
                        '[class]': "css+' '+classCss"
                    },
                    providers: [abstract_ngmodel_1.MakeProvider(ButtonComponent)]
                },] },
    ];
    /** @nocollapse */
    ButtonComponent.ctorParameters = function () { return [
        { type: core_2.TranslateService, },
        { type: http_1.Http, },
        { type: sharedService_1.SharedService, },
    ]; };
    ButtonComponent.propDecorators = {
        "css": [{ type: core_1.Input },],
        "button": [{ type: core_1.ViewChild, args: ['button',] },],
    };
    return ButtonComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.ButtonComponent = ButtonComponent;
