"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var calc_component_1 = require("./calc.component");
var auto_unsubscribe_1 = require("../../models/auto.unsubscribe");
var CalcButtonComponent = /** @class */ (function () {
    function CalcButtonComponent(_viewContainer, _componentFactoryResolver) {
        this._viewContainer = _viewContainer;
        this._componentFactoryResolver = _componentFactoryResolver;
    }
    CalcButtonComponent.prototype.open = function () {
        if (this.modalElRef) {
            this.modalElRef.destroy();
        }
        this.modalElRef = this._viewContainer.createComponent(this._componentFactoryResolver.resolveComponentFactory(calc_component_1.CalcComponent));
        this.modal = this.modalElRef.instance;
        this.modal.modalVisible = true;
    };
    CalcButtonComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-calc-button',
                    template: require('./calc-button.component.html'),
                },] },
    ];
    /** @nocollapse */
    CalcButtonComponent.ctorParameters = function () { return [
        { type: core_1.ViewContainerRef, },
        { type: core_1.ComponentFactoryResolver, },
    ]; };
    CalcButtonComponent = __decorate([
        auto_unsubscribe_1.AutoUnsubscribe(),
        __metadata("design:paramtypes", [core_1.ViewContainerRef, core_1.ComponentFactoryResolver])
    ], CalcButtonComponent);
    return CalcButtonComponent;
}());
exports.CalcButtonComponent = CalcButtonComponent;
