import { ElementRef, OnInit } from '@angular/core';
import { IComponentDefault } from '../../interfaces/IComponentDefault';
import { AbstractNgModel } from '../../models/abstract.ngmodel';
import { TranslateService } from '@ngx-translate/core';
import { SharedService } from '../../models/sharedService';
import { Http } from '@angular/http';
export declare class CheckboxComponent extends AbstractNgModel implements IComponentDefault, OnInit {
    _http: Http;
    private _translateService;
    private _sharedService;
    constructor(_http: Http, _translateService: TranslateService, _sharedService: SharedService);
    input: ElementRef;
    component2: any;
    _indeterminate: boolean;
    valueAux: any;
    indeterminate: any;
    _checked: boolean;
    _checkedPassed: boolean;
    checked: any;
    randomClass: number;
    inputValid: boolean;
    value: any;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    itemClicado(event: any): void;
    itemModificado(event: any): void;
}
