import { EventEmitter, OnInit } from '@angular/core';
import { IComponentDefault } from '../../interfaces/IComponentDefault';
import { AbstractNgModel } from '../../models/abstract.ngmodel';
import { ReqHttpService } from '../../services/req-http.service';
import { SharedService } from "../../models/sharedService";
import { TranslateService } from '@ngx-translate/core';
import { Http } from '@angular/http';
import { DropComponent } from "./drop.component";
import { FilterAllPipe } from "../../pipes/filter.pipe";
export declare class DragComponent extends AbstractNgModel implements OnInit, IComponentDefault {
    private _reqHttpService;
    private _sharedService;
    private _translateService;
    _http: Http;
    private _pipeFilter;
    constructor(_reqHttpService: ReqHttpService, _sharedService: SharedService, _translateService: TranslateService, _http: Http, _pipeFilter: FilterAllPipe);
    droppedItems: any;
    items: any;
    itemsHide: any;
    value: any;
    filterList: any;
    filterSearch: any;
    onDropFromDrop: EventEmitter<{}>;
    callBackDrag: EventEmitter<{}>;
    securityId: string;
    id: string;
    title: string;
    emptyMessage: string;
    textdrag: string;
    keepItems: boolean;
    currentDrag: any;
    _design: string;
    design: string;
    itemSrc: string;
    itemLink: string;
    itemIcon: string;
    itemTitle: string;
    itemDesc: string;
    reqIndex: string;
    itemDisable: string;
    itemTextButton: string;
    iconItems: string;
    iconItems2: string;
    itemButtonHidden: boolean;
    itemButtonHidden2: boolean;
    itemButtonDisabled: boolean;
    itemButtonDisabled2: boolean;
    itemKey: string;
    itemDisabled: boolean;
    dropScope: string[];
    dragScope: string;
    disabled: boolean;
    onDragEnd: EventEmitter<{}>;
    onButtonSelect: EventEmitter<{}>;
    onButtonSelectTwo: EventEmitter<{}>;
    onDrop: EventEmitter<{}>;
    _dataSource: any;
    dataSource: any;
    _columns: any;
    columns: any;
    buttonItemSelect(item: any): void;
    buttonItemSelect2(item: any): void;
    reqService(url: any): void;
    changeDataSorce(val: any): void;
    filterItems(): void;
    dragEndStart(e: any): void;
    dragEnd(e: any): void;
    onItemDrop(e: any): void;
    onItemDropInstance(e: any, dropInstance: DropComponent): void;
    ngOnInit(): void;
}
