import { EventEmitter, OnInit } from '@angular/core';
import { IComponentDefault } from '../../interfaces/IComponentDefault';
import { AbstractNgModel } from '../../models/abstract.ngmodel';
import { SharedService } from "../../models/sharedService";
import { TranslateService } from '@ngx-translate/core';
import { Http } from '@angular/http';
import { FilterAllPipe } from "../../pipes/filter.pipe";
export declare class DropComponent extends AbstractNgModel implements OnInit, IComponentDefault {
    private _sharedService;
    private _translateService;
    _http: Http;
    private _pipeFilter;
    constructor(_sharedService: SharedService, _translateService: TranslateService, _http: Http, _pipeFilter: FilterAllPipe);
    _droppedItems: any;
    droppedItems: any;
    items: any;
    instanceDrag: any;
    value: any;
    filterList: any;
    filterSearch: any;
    dropCircular: boolean;
    callDrop: EventEmitter<{}>;
    callBackRemove: EventEmitter<{}>;
    onDropBack: EventEmitter<{}>;
    isDropped: boolean;
    emptyMessage: string;
    keepItems: boolean;
    _design: string;
    design: string;
    itemSrc: string;
    itemLink: string;
    itemIcon: string;
    itemTitle: string;
    itemTextButton: string;
    itemButtonHidden: boolean;
    itemButtonHidden2: boolean;
    itemButtonDisabled: boolean;
    itemButtonDisabled2: boolean;
    iconItems: string;
    iconItems2: string;
    itemDisabled: boolean;
    itemDesc: string;
    itemKey: string;
    dropScope: string[];
    dropEnabled: boolean;
    labelInstalled: string;
    elementDrop: any;
    onDropItem: EventEmitter<{}>;
    onDragItem: EventEmitter<{}>;
    onButtonSelect: EventEmitter<{}>;
    onButtonSelectTwo: EventEmitter<{}>;
    buttonItemSelect(item: any): void;
    buttonItemSelect2(item: any): void;
    removeIndexes(array: any): any[];
    filterItems(): void;
    dragEndStart(e: any, instanceDrag: any): void;
    dragMoveVars: {
        offsetY: number;
        targetIndex: number;
        targetHash: any;
        siblings: {
            prev: any;
            next: any;
        };
        changesToDo: any[];
    };
    dragMove(e: any, event: any): void;
    dragEnd(e: any, event: any): void;
    onItemDrop(e: any): void;
    clearItems(): void;
    removeItem($item: any): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
}
