import { ElementRef, OnInit, AfterViewInit } from '@angular/core';
import { IComponentDefault } from '../../interfaces/IComponentDefault';
import { AbstractNgModel } from '../../models/abstract.ngmodel';
import { TranslateService } from '@ngx-translate/core';
import { SharedService } from '../../models/sharedService';
import { Http } from '@angular/http';
export declare class FieldsetComponent extends AbstractNgModel implements IComponentDefault, OnInit, AfterViewInit {
    private _sharedService;
    _http: Http;
    private _translateService;
    constructor(_sharedService: SharedService, _http: Http, _translateService: TranslateService);
    fieldset: ElementRef;
    sbmFieldSetContent: ElementRef;
    textWidth: string;
    textAlign: string;
    height: string;
    showborder: any;
    showlabel: any;
    halign: any;
    valign: any;
    _layout: any;
    layout: any;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    setContent: (content: any) => void;
}
