"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var req_http_service_1 = require("../../services/req-http.service");
var abstractFormComponents_1 = require("../../models/abstractFormComponents");
var web_sql_service_1 = require("../../services/web-sql.service");
var indexed_db_service_1 = require("../../services/indexed-db.service");
var FormComponent = /** @class */ (function (_super) {
    __extends(FormComponent, _super);
    function FormComponent(_reqHttpService, _webSqlService, _indexedDBService) {
        var _this = _super.call(this) || this;
        _this._reqHttpService = _reqHttpService;
        _this._webSqlService = _webSqlService;
        _this._indexedDBService = _indexedDBService;
        _this.submit = '';
        _this.reqReturn = '';
        _this.method = null;
        _this.service = null;
        _this.isArray = true;
        //@Input() valign = '';
        //@Input() halign = '';
        _this._submit = new core_1.EventEmitter();
        _this._reqReturn = new core_1.EventEmitter();
        _this.noErrosForm = true;
        return _this;
    }
    FormComponent.prototype.submitForm = function ($data) {
        /*this.submited();
                if(this.formGroup.valid) {
                    this._submit.emit(super.getObject())
                    if (this.submit != '') {
                        window[this.submit](super.getObject());
                    }
        
                    if(this.method && this.service) {
                        this.reqSend($data.value);
                    }
                }*/
        _super.prototype.addFormControls.call(this, $data);
        if ($data.valid) {
            this._submit.emit(_super.prototype.getObject.call(this));
            if (this.submit != '') {
                window[this.submit](_super.prototype.getObject.call(this));
            }
            if (this.method && this.service) {
                this.reqSend($data.value);
            }
        }
    };
    FormComponent.prototype.reqSend = function (data) {
        var _this = this;
        if (this.method.toUpperCase() == 'POST') {
            this._reqHttpService.xhrPost(this.service, (this.isArray ? new Array(data) : data)).subscribe(function (ret) {
                _this._reqReturn.emit(ret);
            }, function (err) {
                _this._reqReturn.emit(err);
            });
        }
        else if (this.method.toUpperCase() == 'PUT') {
            this._reqHttpService.xhrPut(this.service, (this.isArray ? new Array(data) : data)).subscribe(function (ret) {
                _this._reqReturn.emit(ret);
            }, function (err) {
                _this._reqReturn.emit(err);
            });
        }
    };
    FormComponent.prototype.ngAfterViewInit = function () {
        $(document).ready(function () {
            // $(this.crudForm.nativeElement).children().each((index, element) => {
            //     $(element).addClass(this.halign);
            // });
        });
        // this.initForm()
    };
    FormComponent.prototype.ngOnDestroy = function () {
        // this.FormSubscription.unsubscribe();
    };
    FormComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-form',
                    template: require('./form.component.html'),
                },] },
    ];
    /** @nocollapse */
    FormComponent.ctorParameters = function () { return [
        { type: req_http_service_1.ReqHttpService, },
        { type: web_sql_service_1.WebSqlService, },
        { type: indexed_db_service_1.IndexedDBService, },
    ]; };
    FormComponent.propDecorators = {
        "crudForm": [{ type: core_1.ViewChild, args: ['f',] },],
        "submit": [{ type: core_1.Input },],
        "reqReturn": [{ type: core_1.Input, args: ['reqreturn',] },],
        "method": [{ type: core_1.Input },],
        "service": [{ type: core_1.Input },],
        "isArray": [{ type: core_1.Input },],
        "_submit": [{ type: core_1.Output },],
        "_reqReturn": [{ type: core_1.Output },],
    };
    return FormComponent;
}(abstractFormComponents_1.AbstractFormComponents));
exports.FormComponent = FormComponent;
