import { ElementRef, OnInit } from '@angular/core';
import { AbstractNgModel } from '../../../models/abstract.ngmodel';
import { IComponentDefault } from '../../../interfaces/IComponentDefault';
import { TranslateService } from '@ngx-translate/core';
import { SharedService } from '../../../models/sharedService';
import { Http } from '@angular/http';
export declare class InputEmailComponent extends AbstractNgModel implements IComponentDefault, OnInit {
    private _translateService;
    _http: Http;
    private _el;
    private _sharedService;
    constructor(_translateService: TranslateService, _http: Http, _el: ElementRef, _sharedService: SharedService);
    input: ElementRef;
    msgError: string;
    labelWidth: string;
    value: any;
    inputValid: boolean;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    blur(retorno: any): void;
    keyup($event: any): void;
    verificaPadding(): void;
}
