import { ElementRef, OnInit } from '@angular/core';
import { AbstractNgModel } from "../../../models/abstract.ngmodel";
import { IComponentDefault } from "../../../interfaces/IComponentDefault";
import { TranslateService } from "@ngx-translate/core";
import { Http } from "@angular/http";
import { SharedService } from "../../../models/sharedService";
import { Subscription } from "rxjs/Subscription";
export declare class InputIpComponent extends AbstractNgModel implements IComponentDefault, OnInit {
    private _translateService;
    _http: Http;
    private _sharedService;
    private _el;
    constructor(_translateService: TranslateService, _http: Http, _sharedService: SharedService, _el: ElementRef);
    input: ElementRef;
    mask: string;
    valueMask: any;
    changeValue: Subscription;
    changeValueEvent(event: any): void;
    viewSetAttr(): void;
    ngAfterViewInit(): void;
    ngOnInit(): void;
    blur(retorno: any): void;
    keyup($event: any): void;
    limparCampo(): void;
}
