import { Subscription } from 'rxjs';
import { ElementRef, OnInit } from "@angular/core";
import { AbstractNgModel } from "../../../models/abstract.ngmodel";
import { IComponentDefault } from "../../../interfaces/IComponentDefault";
import { TranslateService } from "@ngx-translate/core";
import { SharedService } from "../../../models/sharedService";
import { Http } from '@angular/http';
export declare class InputMaskComponent extends AbstractNgModel implements IComponentDefault, OnInit {
    private _sharedService;
    _http: Http;
    private _el;
    private _translateService;
    constructor(_sharedService: SharedService, _http: Http, _el: ElementRef, _translateService: TranslateService);
    input: ElementRef;
    mask: string;
    inputValid: boolean;
    msgError: string;
    labelWidth: string;
    value: any;
    validationsMsg: any;
    valueMask: any;
    changeValue: Subscription;
    isNotBlank(value: any): any;
    blur(retorno: any): void;
    keyup($event: any): void;
    changeValueEvent(event: any): void;
    ngAfterViewInit(): void;
    ngOnInit(): void;
    verificaPadding(): void;
    limparCampo(): void;
}
