import { Subscription } from 'rxjs';
import { ElementRef, OnInit } from '@angular/core';
import { AbstractNgModel } from '../../../models/abstract.ngmodel';
import { IComponentDefault } from '../../../interfaces/IComponentDefault';
import { TranslateService } from "@ngx-translate/core";
import { SharedService } from "../../../models/sharedService";
import { Http } from '@angular/http';
export declare class InputPasswordComponent extends AbstractNgModel implements IComponentDefault, OnInit {
    private _sharedService;
    _http: Http;
    private _el;
    private _translateService;
    input: ElementRef;
    inputValid: boolean;
    msgError: string;
    labelWidth: string;
    value: any;
    force: number;
    type: string;
    OnChangeValue: Subscription;
    validationsMsg: any;
    constructor(_sharedService: SharedService, _http: Http, _el: ElementRef, _translateService: TranslateService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    forcePassword(element: any): void;
    keyup($event: any): void;
    blur(retorno: any): void;
    ngOnDestroy(): void;
    verificaPadding(): void;
    showPassword(): void;
}
