import { Subscription } from 'rxjs';
import { ElementRef, OnInit } from '@angular/core';
import { AbstractNgModel } from '../../../models/abstract.ngmodel';
import { IComponentDefault } from '../../../interfaces/IComponentDefault';
import { TranslateService } from '@ngx-translate/core';
import { SharedService } from '../../../models/sharedService';
import { Http } from '@angular/http';
export declare class InputTelefoneComponent extends AbstractNgModel implements IComponentDefault, OnInit {
    private _translateService;
    _http: Http;
    private _sharedService;
    private _el;
    constructor(_translateService: TranslateService, _http: Http, _sharedService: SharedService, _el: ElementRef);
    input: ElementRef;
    inputValid: boolean;
    msgError: string;
    labelWidth: string;
    validationsMsg: any;
    value: any;
    valueMask: any;
    changeValue: Subscription;
    blur(retorno: any): void;
    keyup($event: any): void;
    changeValueEvent(event: any): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    verificaPadding(): void;
}
