import { ElementRef, OnInit } from "@angular/core";
import { AbstractNgModel } from "../../../models/abstract.ngmodel";
import { IComponentDefault } from "../../../interfaces/IComponentDefault";
import { TranslateService } from "@ngx-translate/core";
import { SharedService } from "../../../models/sharedService";
import { Subscription } from 'rxjs';
import { Http } from '@angular/http';
export declare class InputTextComponent extends AbstractNgModel implements IComponentDefault, OnInit {
    private _el;
    _http: Http;
    private _sharedService;
    private _translateService;
    constructor(_el: ElementRef, _http: Http, _sharedService: SharedService, _translateService: TranslateService);
    input: ElementRef;
    digitText: string;
    maskExp: string;
    value: any;
    inputValid: boolean;
    msgError: string;
    subscriptionValue: Subscription;
    SubscriptionComp: Subscription;
    isNotBlank(value: any): any;
    regex(value: string): boolean;
    keyup($event: any): void;
    blur(retorno: any): void;
    viewSetAttr(): void;
    ngAfterViewInit(): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
    verificaPadding(): void;
}
