import { ElementRef, EventEmitter, OnInit } from '@angular/core';
import { AbstractNgModel } from '../../../models/abstract.ngmodel';
import { IComponentDefault } from '../../../interfaces/IComponentDefault';
import 'rxjs/add/operator/map';
import { TranslateService } from '@ngx-translate/core';
import { SharedService } from '../../../models/sharedService';
import { Http } from '@angular/http';
export declare class MoneyComponent extends AbstractNgModel implements OnInit, IComponentDefault {
    private _translateService;
    _http: Http;
    private _el;
    private _sharedService;
    constructor(_translateService: TranslateService, _http: Http, _el: ElementRef, _sharedService: SharedService);
    input: ElementRef;
    prefix: string;
    decimal: string;
    min: string;
    max: string;
    thousands: string;
    decimalDigits: string;
    digitAlign: string;
    onFocus: string;
    _onFocus: EventEmitter<{}>;
    _options: any;
    _valueChecked: boolean;
    inputValid: boolean;
    msgInvalid: boolean;
    labelWidth: string;
    msgError: string;
    value: any;
    valueMask: any;
    valueInitial: any;
    blur($event: any): void;
    focus($event: any): void;
    click($event: any): void;
    numberToReal(numero: any): any;
    ngAfterViewInit(): void;
    keyup($event: any): void;
    ngOnInit(): void;
}
