import { ElementRef, OnInit } from '@angular/core';
import { AbstractNgModel } from '../../../models/abstract.ngmodel';
import { IComponentDefault } from '../../../interfaces/IComponentDefault';
import { TranslateService } from '@ngx-translate/core';
import { SharedService } from '../../../models/sharedService';
import { Http } from '@angular/http';
export declare class TextareaComponent extends AbstractNgModel implements IComponentDefault, OnInit {
    private _el;
    private _translateService;
    _http: Http;
    private _sharedService;
    constructor(_el: ElementRef, _translateService: TranslateService, _http: Http, _sharedService: SharedService);
    textarea: ElementRef;
    digitText: string;
    private tmLinha;
    private _rows;
    rows: string;
    inputValid: boolean;
    msgError: string;
    labelWidth: string;
    value: any;
    blur($event: any): void;
    keyup($event: any): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
}
