import { ElementRef, OnInit, QueryList } from '@angular/core';
import { AbstractNgModel } from '../../models/abstract.ngmodel';
import { IComponentDefault } from '../../interfaces/IComponentDefault';
import { IListview } from '../../interfaces/IListview';
import { TranslateService } from '@ngx-translate/core';
import { SharedService } from '../../models/sharedService';
import { Http } from '@angular/http';
import { MatSelectionList } from '@angular/material';
import { ListOptions } from './list-option.component';
export declare class ListViewComponent extends AbstractNgModel implements IComponentDefault, OnInit {
    private _translateService;
    _http: Http;
    private _sharedService;
    constructor(_translateService: TranslateService, _http: Http, _sharedService: SharedService);
    listOption: QueryList<ListOptions>;
    listOptionsEl: ElementRef;
    listOptions: MatSelectionList;
    dataSource: IListview[];
    maxHeight: number;
    textAlign: string;
    height: string;
    showborder: any;
    showlabel: any;
    itemsSelected: any[];
    selectionMultiple: boolean;
    _onRemove: any;
    _onAdd: any;
    _dataSource: any;
    sbmListView: any;
    msgError: string;
    styleClass: string;
    filterList: any;
    checkedAll: boolean;
    selectedItems: any[];
    randomClass: number;
    setValue: boolean;
    selectedAll: boolean;
    _value: any[];
    value: any;
    valueDisplay: any;
    validateList(): void;
    selectItem(item: ListOptions): void;
    selectAll(): void;
    arraysEqual(arr1: any, arr2: any): any[];
    ngAfterViewInit(): void;
    changeList(data: any): void;
    ngOnInit(): void;
}
