"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../models/sharedService");
var http_1 = require("@angular/http");
var material_1 = require("@angular/material");
var list_option_component_1 = require("./list-option.component");
var ListViewComponent = /** @class */ (function (_super) {
    __extends(ListViewComponent, _super);
    function ListViewComponent(_translateService, _http, _sharedService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._sharedService = _sharedService;
        _this.dataSource = [];
        _this.maxHeight = 300;
        _this.textAlign = "";
        _this.height = "";
        _this.showborder = "true";
        _this.showlabel = "true";
        _this.itemsSelected = [];
        _this.selectionMultiple = false;
        _this._onRemove = new core_1.EventEmitter();
        _this._onAdd = new core_1.EventEmitter();
        // component: any = {
        //     valid: true,
        //     invalidRequire: false,
        // };
        _this._dataSource = ["Valor"];
        _this.msgError = "Selecione um valor";
        _this.styleClass = "";
        _this.filterList = null;
        _this.checkedAll = false;
        _this.selectedItems = [];
        _this.randomClass = 0;
        _this.setValue = true;
        _this.selectedAll = false;
        _this._value = [];
        sbmListViewComponent.push(_this);
        return _this;
    }
    ListViewComponent.prototype.validateList = function () {
        /*if (this.value) {
                    if (this.value.length == 0) {
                        this.component.valid = false;
                        this.component.invalidRequire = true;
                    } else {
                        this.component.valid = true;
                        this.component.invalidRequire = false;
                    }
                } else {
                    this.component.valid = false;
                    this.component.invalidRequire = true;
                }*/
    };
    ListViewComponent.prototype.selectItem = function (item) { };
    ListViewComponent.prototype.selectAll = function () {
        if (this.selectedAll) {
            this.listOptions.deselectAll();
            this.value = [];
        }
        else {
            this.listOptions.selectAll();
        }
        this.selectedAll = !this.selectedAll;
    };
    ListViewComponent.prototype.arraysEqual = function (arr1, arr2) {
        var ret = [];
        arr1.sort();
        arr2.sort();
        for (var i = 0; i < arr1.length; i += 1) {
            if (arr2.indexOf(arr1[i]) > -1) {
                ret.push(arr1[i]);
            }
        }
        return ret;
    };
    ListViewComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        var subscription;
        subscription = this.onChangeValue.subscribe(function (ret) {
            if (typeof ret == "object") {
                if (ret.length > 0) {
                    _this.listOptions.deselectAll();
                    ret.map(function (e) {
                        _this.listOptions.options.forEach(function (a, i) {
                            if (JSON.stringify(a.value) == JSON.stringify(e)) {
                                a.selected = true;
                            }
                        });
                    });
                }
            }
            else {
                _this.listOption.forEach(function (a, i) {
                    if (a.value == ret) {
                        a.active = true;
                    }
                });
            }
        });
    };
    ListViewComponent.prototype.changeList = function (data) {
        var _this = this;
        this.listOptions.options.forEach(function (a, i) {
            if (JSON.stringify(a.value) == JSON.stringify(data.value)) {
                if (!a.selected) {
                    _this._onRemove.emit(data.value);
                }
                else {
                    _this._onAdd.emit(data.value);
                }
            }
        });
        this._value = [];
        this.listOptions.selectedOptions.selected.map(function (itm) {
            if (itm.value) {
                _this._value.push(itm.value);
            }
        });
        this.value = this._value;
        if (this.notnull) {
            this.validateList();
        }
        this._onClick.emit(this.value);
        if (this.onClick != "") {
            window[this.onClick](this.value);
        }
    };
    ListViewComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this.css += " sbm-list-view";
        this.classCss += " " + this.css;
    };
    ListViewComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: "sbm-list-view",
                    template: require('./list-view.component.html'),

                    styles: [require('./list-view.component.css')],
                    host: {
                        "[class]": "classCss",
                        "[style]": "styleClass"
                    },
                    providers: [
                        abstract_ngmodel_1.MakeProvider(ListViewComponent),
                        {
                            provide: abstract_ngmodel_1.AbstractNgModel,
                            useExisting: core_1.forwardRef(function () { return ListViewComponent; })
                        }
                    ]
                },] },
    ];
    /** @nocollapse */
    ListViewComponent.ctorParameters = function () { return [
        { type: core_2.TranslateService, },
        { type: http_1.Http, },
        { type: sharedService_1.SharedService, },
    ]; };
    ListViewComponent.propDecorators = {
        "listOption": [{ type: core_1.ContentChildren, args: [core_1.forwardRef(function () { return list_option_component_1.ListOptions; }),] },],
        "listOptionsEl": [{ type: core_1.ViewChild, args: ["listOptionsEl",] },],
        "listOptions": [{ type: core_1.ViewChild, args: ["options",] },],
        "dataSource": [{ type: core_1.Input },],
        "maxHeight": [{ type: core_1.Input, args: ["maxheight",] },],
        "textAlign": [{ type: core_1.Input },],
        "height": [{ type: core_1.Input },],
        "showborder": [{ type: core_1.Input },],
        "showlabel": [{ type: core_1.Input },],
        "itemsSelected": [{ type: core_1.Input },],
        "selectionMultiple": [{ type: core_1.Input, args: ["selectionmultiple",] },],
        "_onRemove": [{ type: core_1.Output },],
        "_onAdd": [{ type: core_1.Output },],
    };
    return ListViewComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.ListViewComponent = ListViewComponent;
