"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var MasterDetailFormGenericComponent = /** @class */ (function () {
    function MasterDetailFormGenericComponent(_el) {
        this._el = _el;
        this.hide = false;
        this.breadcrumb = [];
    }
    MasterDetailFormGenericComponent.prototype.removeBreadCrumb = function (b) {
        this.crud.removeBreadcrumbMasterDetail(b);
    };
    MasterDetailFormGenericComponent.prototype.ngAfterViewInit = function () {
    };
    MasterDetailFormGenericComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-master-detail-container',
                    template: "\n        <div class=\"col s12 m12 l12 crud-breadcrumb\">\n            <nav>\n                <div class=\"nav-wrapper\">\n                <div class=\"col s12\">\n                    <span (click)=\"removeBreadCrumb(b)\" class=\"breadcrumb blue-text\" *ngFor=\"let b of breadcrumb\">{{b.label}}</span>\n                </div>\n                </div>\n            </nav>\n        </div>\n        <div class=\"row\">\n            <ng-template [ngTemplateOutlet]=\"masterDetailTemplate\" [ngTemplateOutletContext]=\"{ item: item }\"></ng-template>\n        </div>\n    ",
                    host: {
                        '[hidden]': 'hide',
                        'class': 'row'
                    },
                },] },
    ];
    /** @nocollapse */
    MasterDetailFormGenericComponent.ctorParameters = function () { return [
        { type: core_1.ElementRef, },
    ]; };
    return MasterDetailFormGenericComponent;
}());
exports.MasterDetailFormGenericComponent = MasterDetailFormGenericComponent;
