"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var req_http_service_1 = require("../../services/req-http.service");
var alert_component_1 = require("../alert/alert.component");
var grid_component_1 = require("../grid/grid.component");
var notification_component_1 = require("../notification/notification.component");
var master_detail_form_component_1 = require("../master-detail-form/master-detail-form.component");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../models/sharedService");
var http_1 = require("@angular/http");
var material_1 = require("@angular/material");
var sbm_http_client_service_1 = require("../../services/sbm-http-client.service");
var dialog_audit_component_1 = require("../../components/crud/dialog-audit/dialog-audit.component");
var funcoes_component_1 = require("../../models/funcoes.component");
var devextreme_angular_1 = require("devextreme-angular");
var MatDialogConfig = /** @class */ (function () {
    function MatDialogConfig() {
    }
    return MatDialogConfig;
}());
var MasterDetailComponent = /** @class */ (function (_super) {
    __extends(MasterDetailComponent, _super);
    function MasterDetailComponent(_reqHttpService, _sharedService, _http, _translateService, dialog, elRef, vcRef, sbmHttpClient) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._reqHttpService = _reqHttpService;
        _this._sharedService = _sharedService;
        _this._http = _http;
        _this._translateService = _translateService;
        _this.dialog = dialog;
        _this.elRef = elRef;
        _this.vcRef = vcRef;
        _this.sbmHttpClient = sbmHttpClient;
        _this.id = "";
        _this.securityId = "";
        _this.attribute = "";
        _this.saveServer = false;
        _this.urlAction = null;
        _this.entity = null;
        _this.dataSource = [];
        _this.notnull = false;
        _this._enableActions = true;
        _this._columns = "col l12 m12 s12 crud-form-dynamic sbm-master-detail";
        _this.formVisible = false;
        _this.showBackdrop = false;
        _this.gridMasterDetail = false;
        _this.formMasterDetail = true;
        _this.update = {
            key: null,
            refresh: false
        };
        _this.inputValid = true;
        _this.msgError = "Campo Incorreto";
        _this.randomClass = 0;
        _this.loadedReq = new core_1.EventEmitter();
        _this._valueVerified = true;
        _this.generatedEntity = {};
        _this.valueEntity = {};
        _this.value = [];
        _this.newFormMasterDetail = new core_1.EventEmitter();
        _this.cancelFormMasterDetail = new core_1.EventEmitter();
        _this.validationsMsg = {
            require: null,
            MasterDetailRemoveItem: null,
            MasterDetailRemoveYes: null,
            MasterDetailRemoveCancel: null,
            MasterDetailRemoveSuccess: null,
            MasterDetailCancelAddItem: null,
            MasterDetailAddItem: null
        };
        _this.addDinamicparameter = [];
        sbmMasterDetailComponent.push(_this);
        return _this;
    }
    Object.defineProperty(MasterDetailComponent.prototype, "enableActions", {
        get: function () {
            return this._enableActions;
        },
        set: function (val) {
            if (val == "true") {
                this._enableActions = true;
            }
            else {
                this._enableActions = false;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MasterDetailComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "col l" + value + " m12 s12 crud-form-dynamic sbm-master-detail";
        },
        enumerable: true,
        configurable: true
    });
    MasterDetailComponent.prototype.isAudityEnabled = function () {
        return (this.entity !== null &&
            this.parentEntity !== undefined &&
            this.parentEntityId !== undefined);
    };
    MasterDetailComponent.prototype.itemEdit = function () {
        var _this = this;
        var keys = Object.keys(this.grid.instance.getSelectedRowsData()[0]);
        this.sbmMasterDetailForm.first.buttonText = "Salvar";
        this.sbmMasterDetailForm.forEach(function (item) {
            if (_this.id == item.elementRef) {
                for (var _i = 0, keys_1 = keys; _i < keys_1.length; _i++) {
                    var i = keys_1[_i];
                    item.setValue(i, _this.grid.instance.getSelectedRowsData()[0][i]);
                }
                _this.update.refresh = true;
                _this.update.key = _this.grid.instance.getRowIndexByKey(_this.grid.instance.getSelectedRowsData()[0]);
                _this.itemNew(_this);
            }
        });
    };
    MasterDetailComponent.prototype.validInput = function () {
        if (this.notnull && this.value.length == 0) {
            this.inputValid = false;
            this.msgError = this.validationsMsg["require"];
        }
        else {
            this.inputValid = true;
        }
    };
    MasterDetailComponent.prototype.itemRemove = function ($data) {
        var _this = this;
        var alert = new alert_component_1.AlertComponent();
        var notification = new notification_component_1.NotificationComponent();
        alert
            .show("Deseja realmente remover este item?", "Sim", "", "warning", true, "Cancelar")
            .then(function (ret) {
            if (ret) {
                _this.value.map(function (v, i) {
                    if (v == _this.grid.instance.getSelectedRowsData()[0]) {
                        _this.value.splice(i, 1);
                        notification.show("Removido com sucesso");
                        _this.validInput();
                    }
                });
                if (_this.value.length == 0) {
                    _this.value = null;
                }
            }
        });
    };
    MasterDetailComponent.prototype.cancelForm = function () {
        this.sbmMasterDetailForm.first.cancel();
        this.cancelFormMasterDetail.emit(true);
    };
    MasterDetailComponent.prototype.itemNew = function ($class) {
        var _this = this;
        this.gridMasterDetail = true;
        this.formMasterDetail = false;
        var emitForm;
        emitForm = this.sbmMasterDetailForm.first.formMasterDetail.subscribe(function (ret) {
            if (!_this.value) {
                _this.value = [];
            }
            if (_this.update.refresh) {
                $class.value[_this.update.key] = ret;
                _this.update.refresh = false;
                _this.sbmMasterDetailForm.first.buttonText = "Adicionar";
            }
            else {
                _this.sbmMasterDetailForm.first.buttonText = "Adicionar";
                $class.value.push(ret);
                _this.validInput();
            }
            _this.sbmMasterDetailForm.first.clearForm();
            _this.cancelFormMasterDetail.emit(true);
            emitForm.unsubscribe();
        });
        this.sbmMasterDetailForm.first.cancelForm.subscribe(function (ret) {
            if (ret.cancel) {
                _this.cancelFormMasterDetail.emit(true);
                _this.update.refresh = false;
                _this.update.key = null;
                emitForm.unsubscribe();
                _this.sbmMasterDetailForm.first.buttonText = "Adicionar";
            }
        });
        this.newFormMasterDetail.emit(true);
        // this.showBackdrop = true;
        // this.fieldset.nativeElement.style.zIndex = 1001;
    };
    MasterDetailComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.randomClass = Math.floor(Math.random() * 1000 + 1);
        _super.prototype.validar.call(this, this.securityId);
        this._translateService.onLangChange.subscribe(function () {
            var retTraducao = _this._sharedService.getTraducao("sabium-framework")[0];
            _this.validationsMsg["require"] = retTraducao["validation.notNull"];
        });
    };
    MasterDetailComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.sbmMasterDetailForm.first.elementRef = this.id;
        this.dataColumns.forEach(function (a, i) {
            if (a.isEntity) {
                _this.generatedEntity[a.value] = [];
                _this.valueEntity[a.value] = [];
                _this._reqHttpService
                    .xhrGet("/sabium/api/" + a.entity)
                    .subscribe(function (ret) {
                    _this.generatedEntity[a.value] = ret.res.data;
                    setTimeout(function () {
                        _this.loadedReq.emit(true);
                    }, 1000);
                });
            }
        });
    };
    MasterDetailComponent.prototype.ngAfterViewChecked = function (change) {
        if (this.value && this._valueVerified) {
            if (this.value.length > 0) {
                this.dataSource = this.value;
                this._valueVerified = false;
            }
        }
    };
    MasterDetailComponent.prototype.audit = function () {
        var _this = this;
        var selection = this.grid.selectedRowKeys.length > 0
            ? this.grid.selectedRowKeys[0].id
            : false;
        var url = "/sabium/api/auditoria/aplicacao/" + _projectCodigo + "/";
        url += selection
            ? "entidade/" + this.entity + "/registro/" + selection
            : "entidadepai/" + this.parentEntity + "/registropai/" + this.parentEntityId + "/entidade/" + this.entity;
        this.sbmHttpClient.get(url).subscribe(function (ret) {
            if (ret) {
                var audit = ret.data;
                audit.forEach(function (ret) {
                    ret["data"] = funcoes_component_1.FuncoesComponent.formatarData(ret.dataHora);
                    switch (ret["operacao"]) {
                        case "INCLUSAO":
                            ret["operacao"] = "Inclusão";
                            break;
                        case "ATUALIZACAO":
                            ret["operacao"] = "Atualização";
                            break;
                        case "REMOCAO":
                            ret["operacao"] = "Remoção";
                            break;
                    }
                    var details = JSON.parse(ret.detalhes);
                    details.forEach(function (element) {
                        var keys = Object.keys(element);
                        element["lista"] = [];
                        keys.forEach(function (key) {
                            element["lista"].push({
                                chave: key,
                                valor: element[key]
                            });
                            // lista.push({'item': element, lista: element['lista']})
                        });
                    });
                    ret["detalhesLista"] = details;
                });
                if (ret.data.length > 0) {
                    var configDialog = Object.assign(new MatDialogConfig(), {
                        height: "600px",
                        data: audit
                    });
                    _this.dialog.open(dialog_audit_component_1.DialogAuditDetail, configDialog);
                }
            }
            else {
                var notification = new notification_component_1.NotificationComponent();
                notification.show("Não existem alterações para este registro!");
            }
        });
    };
    MasterDetailComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-master-detail',
                    template: require('./master-detail.component.html'),

                    styles: [require('./master-detail.component.css')],
                    host: {
                        "[class]": "columns"
                    },
                    providers: [
                        abstract_ngmodel_1.MakeProvider(MasterDetailComponent),
                        {
                            provide: abstract_ngmodel_1.AbstractNgModel,
                            useExisting: core_1.forwardRef(function () { return MasterDetailComponent; })
                        }
                    ]
                },] },
    ];
    /** @nocollapse */
    MasterDetailComponent.ctorParameters = function () { return [
        { type: req_http_service_1.ReqHttpService, },
        { type: sharedService_1.SharedService, },
        { type: http_1.Http, },
        { type: core_2.TranslateService, },
        { type: material_1.MatDialog, },
        { type: core_1.ElementRef, },
        { type: core_1.ViewContainerRef, },
        { type: sbm_http_client_service_1.SbmHttpClientService, },
    ]; };
    MasterDetailComponent.propDecorators = {
        "dataColumns": [{ type: core_1.ContentChildren, args: [grid_component_1.SbmGridColumn,] },],
        "sbmMasterDetailForm": [{ type: core_1.ContentChildren, args: [master_detail_form_component_1.SbmMasterDetailForm, { descendants: true },] },],
        "sbmMasterDetailFormView": [{ type: core_1.ViewChild, args: [master_detail_form_component_1.SbmMasterDetailForm,] },],
        "form": [{ type: core_1.ViewChild, args: ["form",] },],
        "grid": [{ type: core_1.ViewChild, args: ["grid",] },],
        "fieldset": [{ type: core_1.ViewChild, args: ["fieldset",] },],
        "formTemplate": [{ type: core_1.ViewChild, args: ["internalTemplateForm",] },],
        "id": [{ type: core_1.Input },],
        "securityId": [{ type: core_1.Input, args: ['securityid',] },],
        "attribute": [{ type: core_1.Input },],
        "saveServer": [{ type: core_1.Input },],
        "urlAction": [{ type: core_1.Input },],
        "entity": [{ type: core_1.Input },],
        "dataSource": [{ type: core_1.Input },],
        "notnull": [{ type: core_1.Input, args: ["require",] },],
        "enableActions": [{ type: core_1.Input, args: ["enableactions",] },],
        "columns": [{ type: core_1.Input },],
    };
    return MasterDetailComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.MasterDetailComponent = MasterDetailComponent;
var DialogMasterDetail = /** @class */ (function () {
    function DialogMasterDetail(dialog, data) {
        this.dialog = dialog;
        this.data = data;
    }
    DialogMasterDetail.prototype.onNoClick = function () {
        this.dialog.close();
    };
    DialogMasterDetail.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-dialog-master-detail',
                    template: "\n        <ng-template [ngTemplateOutlet]=\"data.template\" [ngTemplateOutletContext]=\"{ item: null }\"></ng-template>\n    ",
                },] },
    ];
    /** @nocollapse */
    DialogMasterDetail.ctorParameters = function () { return [
        { type: material_1.MatDialogRef, },
        { type: undefined, decorators: [{ type: core_1.Inject, args: [material_1.MAT_DIALOG_DATA,] },] },
    ]; };
    return DialogMasterDetail;
}());
exports.DialogMasterDetail = DialogMasterDetail;
