import { TranslateService } from '@ngx-translate/core';
import { Http } from '@angular/http';
import { ElementRef, OnInit } from '@angular/core';
import { AbstractNgModel } from "../../models/abstract.ngmodel";
import { IComponentDefault } from "../../interfaces/IComponentDefault";
import { SharedService } from "../../models/sharedService";
export declare class MultiselectDropdownComponent extends AbstractNgModel implements IComponentDefault, OnInit {
    private _translateService;
    _http: Http;
    private _sharedService;
    constructor(_translateService: TranslateService, _http: Http, _sharedService: SharedService);
    multiSelectDropdown: ElementRef;
    content: ElementRef;
    id: string;
    name: string;
    textField: string;
    dataSource: any;
    css: string;
    _attr: string;
    attribute: string;
    _columns: any;
    columns: any;
    getWidth: any;
    listviewvalue: any;
    randowString: string;
    value: any;
    initMultiselect(): void;
    ngAfterViewInit(): void;
    ngOnInit(): void;
}
