import { Subscription } from 'rxjs';
import { ElementRef, OnInit } from '@angular/core';
import { AbstractNgModel } from '../../models/abstract.ngmodel';
import { IComponentDefault } from '../../interfaces/IComponentDefault';
import { TranslateService } from '@ngx-translate/core';
import { SharedService } from '../../models/sharedService';
import { Http } from '@angular/http';
import { MatChipInputEvent } from '@angular/material';
import { ReqHttpService } from "../../services/req-http.service";
export declare class MultiselectComponent extends AbstractNgModel implements IComponentDefault, OnInit {
    private _el;
    private _translateService;
    _http: Http;
    _reqHttp: ReqHttpService;
    private _sharedService;
    constructor(_el: ElementRef, _translateService: TranslateService, _http: Http, _reqHttp: ReqHttpService, _sharedService: SharedService);
    input: ElementRef;
    component: any;
    containerChip: ElementRef;
    chips: ElementRef;
    isEmail: boolean;
    imgChip: boolean;
    insertDynamycallyDataSource: boolean;
    visible: boolean;
    selectable: boolean;
    removable: boolean;
    addOnBlur: boolean;
    separatorKeysCodes: number[];
    inputValue: any;
    ValueChange: Subscription;
    inputValid: boolean;
    _value: any;
    value: any;
    notRender: boolean;
    valueInsert: any;
    randomDrop: any;
    _dataSource: any[];
    reqSucess: boolean;
    currentItem: any;
    valueInitial: boolean;
    dinamicList: any;
    private __dataSource;
    dataSource: any;
    devolveItemEval(colA: any, rec: any, pos?: number): any;
    validateList(): void;
    reqService(): void;
    itemClicked(item: any): void;
    addObject(obj: any): void;
    add(event: MatChipInputEvent): void;
    remove(item: any): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
}
