"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../models/sharedService");
var http_1 = require("@angular/http");
var keycodes_1 = require("@angular/cdk/keycodes");
var req_http_service_1 = require("../../services/req-http.service");
var COMMA = 188;
var MultiselectComponent = /** @class */ (function (_super) {
    __extends(MultiselectComponent, _super);
    function MultiselectComponent(_el, _translateService, _http, _reqHttp, _sharedService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._el = _el;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._reqHttp = _reqHttp;
        _this._sharedService = _sharedService;
        _this.component = {
            valid: true
        };
        _this.isEmail = false;
        _this.imgChip = false;
        _this.insertDynamycallyDataSource = false;
        _this.visible = true;
        _this.selectable = true;
        _this.removable = true;
        _this.addOnBlur = false;
        _this.separatorKeysCodes = [keycodes_1.ENTER, COMMA];
        _this.inputValid = true;
        _this._value = [];
        _this.notRender = false;
        _this.valueInsert = "";
        _this._dataSource = [];
        _this.reqSucess = false;
        _this.valueInitial = true;
        _this.dinamicList = [];
        sbmMultiSelectComponent.push(_this);
        return _this;
    }
    Object.defineProperty(MultiselectComponent.prototype, "dataSource", {
        get: function () {
            return this.__dataSource;
        },
        set: function (val) {
            var _this = this;
            this.__dataSource = val;
            if (typeof val == "object") {
                var req_1 = [];
                val.map(function (a) {
                    var newItem = {
                        label: "",
                        active: false,
                        data: a
                    };
                    for (var count = 0; count < _this.text.length; count++) {
                        if (_this.text.length > 1) {
                            if (_this.text[count].indexOf(".") > -1) {
                                var rec = _this.text[count].split(".");
                                var recTraducao = _this.devolveItemEval(a, rec);
                                newItem["label"] += recTraducao + " " + (_this.text.length == count + 1
                                    ? ""
                                    : _this.textSeparator) + " ";
                            }
                            else {
                                newItem["label"] += a[_this.text[count]] + " " + (_this.text.length == count + 1
                                    ? ""
                                    : _this.textSeparator) + " ";
                            }
                        }
                        else {
                            if (_this.text[count].indexOf(".") > -1) {
                                var rec = _this.text[count].split(".");
                                var recTraducao = _this.devolveItemEval(a, rec);
                                newItem["label"] = recTraducao;
                            }
                            else {
                                newItem["label"] = a[_this.text[count]];
                            }
                        }
                    }
                    req_1.push(newItem);
                });
                this._dataSource = req_1;
            }
            else {
                this.reqService();
            }
        },
        enumerable: true,
        configurable: true
    });
    MultiselectComponent.prototype.devolveItemEval = function (colA, rec, pos) {
        if (pos === void 0) { pos = 0; }
        var objAtual = rec[pos];
        if (pos < rec.length - 1) {
            if (colA[objAtual]) {
                return this.devolveItemEval(colA[objAtual], rec, ++pos);
            }
            else {
                return "";
            }
        }
        return colA[objAtual];
    };
    MultiselectComponent.prototype.validateList = function () {
        if (this.component !== undefined) {
            if (this.value) {
                if (this.value.length == 0) {
                    this.component.valid = false;
                }
                else {
                    this.component.valid = true;
                }
            }
            else {
                this.component.valid = false;
            }
        }
    };
    MultiselectComponent.prototype.reqService = function () {
        var _this = this;
        if (!this.reqSucess) {
            if (this.dataSource != "" && this.dataSource) {
                this._reqHttp.xhrGet(this.dataSource).subscribe(function (ret) {
                    var req = [];
                    ret.res[_this.reqIndexKey].map(function (a) {
                        a["labelText"] = "";
                        for (var count = 0; count < _this.text.length; count++) {
                            if (_this.text.length > 1) {
                                a["labelText"] += a[_this.text[count]] + " " + (_this.text.length == count + 1
                                    ? ""
                                    : _this.textSeparator) + " ";
                            }
                            else {
                                a["labelText"] = a[_this.text[count]];
                            }
                        }
                        req.push(a);
                    });
                    _this.dataSource = req;
                    _this.reqSucess = true;
                }, function (err) {
                    _this.reqSucess = false;
                    console.error("Ocorreu um erro na chamada do serviço =>", err);
                    _this.inputValid = false;
                });
            }
        }
    };
    MultiselectComponent.prototype.itemClicked = function (item) {
        if (this._value.length > 0) {
            var filter = this._value.filter(function (ret) { return ret == item.label; });
            if (filter.length == 0) {
                this._value.push(item.label);
                this.value = this._value;
            }
            else {
                var index = this._value.indexOf(filter[0]);
                this._value.splice(index, 1);
                this.value = this._value;
            }
        }
        else {
            this._value.push(item.label);
            this.value = this._value;
        }
        this.inputValue = "";
        if (this.notnull) {
            this.validateList();
        }
    };
    MultiselectComponent.prototype.addObject = function (obj) {
        // Add our item
        if ((obj.value || "").trim()) {
            var filter = this._value.filter(function (ret) { return ret == obj.value.trim(); });
            if (filter.length == 0) {
                this._value.push(obj.value.trim());
            }
            else {
                var index = this._value.indexOf(filter[0]);
                this._value.splice(index, 1);
            }
        }
        // Reset the input value
        if (obj.input) {
            obj.input.value = "";
        }
        this.value = this._value;
        if (this.notnull) {
            this.validateList();
        }
    };
    MultiselectComponent.prototype.add = function (event) {
        var obj = {
            input: event.input,
            value: event.value
        };
        this.addObject(obj);
    };
    MultiselectComponent.prototype.remove = function (item) {
        var index = this._value.indexOf(item);
        if (index >= 0) {
            this._value.splice(index, 1);
        }
        this.value = this._value;
        if (this.notnull) {
            this.validateList();
        }
    };
    MultiselectComponent.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.validar.call(this, this.securityId);
        this.css += " sbm-input sbm-multiselect";
        this.classCss += " " + this.css;
        this.ValueChange = this.onChangeValue.subscribe(function (ret) {
            if (ret) {
                if (typeof ret == "object") {
                    if (ret.length > 0) {
                        ret.map(function (v, i) {
                            var filter = _this._value.filter(function (ret) { return ret == v; });
                            if (filter.length == 0) {
                                _this._value.push(v);
                            }
                            if (_this._dataSource.length > 0) {
                                _this._dataSource.map(function (item) {
                                    if (item.label == v) {
                                        item.active = true;
                                    }
                                });
                            }
                        });
                    }
                    else {
                        _this._value = [];
                    }
                }
                _this.ValueChange.unsubscribe();
            }
        });
        this.onChangeValue.subscribe(function (ret) {
            if (ret) {
                if (ret.length == 0) {
                    _this._value = [];
                }
            }
            else {
                _this._value = [];
            }
        });
    };
    MultiselectComponent.prototype.ngAfterViewInit = function () {
        if (this.documentation != "") {
            $(this._el.nativeElement).addClass("sbm-documentation");
        }
    };
    MultiselectComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: "sbm-multiselect",
                    template: require('./multiselect.component.html'),

                    host: {
                        "[class]": "classCss"
                    },
                    providers: [
                        abstract_ngmodel_1.MakeProvider(MultiselectComponent),
                        {
                            provide: abstract_ngmodel_1.AbstractNgModel,
                            useExisting: core_1.forwardRef(function () { return MultiselectComponent; })
                        }
                    ]
                },] },
    ];
    /** @nocollapse */
    MultiselectComponent.ctorParameters = function () { return [
        { type: core_1.ElementRef, },
        { type: core_2.TranslateService, },
        { type: http_1.Http, },
        { type: req_http_service_1.ReqHttpService, },
        { type: sharedService_1.SharedService, },
    ]; };
    MultiselectComponent.propDecorators = {
        "input": [{ type: core_1.ViewChild, args: ["multiselect",] },],
        "containerChip": [{ type: core_1.ViewChild, args: ["containerChip",] },],
        "chips": [{ type: core_1.ViewChild, args: ["chips",] },],
        "isEmail": [{ type: core_1.Input, args: ["isemail",] },],
        "imgChip": [{ type: core_1.Input, args: ["imgchip",] },],
        "insertDynamycallyDataSource": [{ type: core_1.Input, args: ["insertDynamycallyDataSource",] },],
        "dataSource": [{ type: core_1.Input, args: ["datasource",] },],
    };
    return MultiselectComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.MultiselectComponent = MultiselectComponent;
