"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var sharedService_1 = require("../../models/sharedService");
var http_1 = require("@angular/http");
var core_2 = require("@ngx-translate/core");
var ProgressbarComponent = /** @class */ (function (_super) {
    __extends(ProgressbarComponent, _super);
    function ProgressbarComponent(_sharedService, _http, _el, _translateService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._http = _http;
        _this._el = _el;
        _this._translateService = _translateService;
        _this.min = 0;
        _this.max = 100;
        _this.statusDisplay = function (value) {
            return "" + Math.round(value * 100) + "%";
        };
        return _this;
    }
    ProgressbarComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this.css += " sbm-progressbar";
        this.columns += " " + this.css;
    };
    ProgressbarComponent.prototype.ngAfterViewInit = function () {
        if (this.documentation != "") {
            $(this._el.nativeElement).addClass("sbm-documentation");
        }
    };
    ProgressbarComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: "sbm-progressbar",
                    template: require('./progressbar.component.html'),

                    host: {
                        "[class]": "columns"
                    },
                    providers: [abstract_ngmodel_1.MakeProvider(ProgressbarComponent)]
                },] },
    ];
    /** @nocollapse */
    ProgressbarComponent.ctorParameters = function () { return [
        { type: sharedService_1.SharedService, },
        { type: http_1.Http, },
        { type: core_1.ElementRef, },
        { type: core_2.TranslateService, },
    ]; };
    ProgressbarComponent.propDecorators = {
        "min": [{ type: core_1.Input },],
        "max": [{ type: core_1.Input },],
    };
    return ProgressbarComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.ProgressbarComponent = ProgressbarComponent;
