import { Subscription } from 'rxjs';
import { ElementRef, EventEmitter, OnInit, QueryList } from '@angular/core';
import { IComponentDefault } from '../../interfaces/IComponentDefault';
import { AbstractNgModel } from '../../models/abstract.ngmodel';
import { TranslateService } from '@ngx-translate/core';
import { SharedService } from '../../models/sharedService';
import { Http } from '@angular/http';
import { RadioOptions } from "./radio-option.component";
export declare class RadioComponent extends AbstractNgModel implements IComponentDefault, OnInit {
    private _el;
    private _translateService;
    _http: Http;
    private _sharedService;
    constructor(_el: ElementRef, _translateService: TranslateService, _http: Http, _sharedService: SharedService);
    radioOptions: QueryList<RadioOptions>;
    component: any;
    dataSource: any[];
    _dataSource: any;
    _onClick: EventEmitter<{}>;
    onClick: string;
    notnull: boolean;
    textAlign: string;
    height: string;
    showborder: any;
    showlabel: any;
    inputValid: boolean;
    msgError: string;
    randomClass: number;
    value: any;
    _label: any;
    onValueChange: Subscription;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
}
export declare enum RadioEnumOrientation {
    horizontal = 0,
    vertical = 1,
}
