"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../models/sharedService");
var http_1 = require("@angular/http");
var radio_option_component_1 = require("./radio-option.component");
var RadioComponent = /** @class */ (function (_super) {
    __extends(RadioComponent, _super);
    function RadioComponent(_el, _translateService, _http, _sharedService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._el = _el;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._sharedService = _sharedService;
        _this.dataSource = [];
        _this._dataSource = [];
        _this._onClick = new core_1.EventEmitter();
        _this.onClick = "";
        _this.notnull = false;
        _this.textAlign = "";
        _this.height = "";
        _this.showborder = "true";
        _this.showlabel = "true";
        _this.inputValid = true;
        _this.msgError = "Campo Incorreto";
        _this.randomClass = 0;
        _this._label = "";
        sbmRadioComponent.push(_this);
        return _this;
    }
    RadioComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this.css += " sbm-radio";
        this.classCss += " " + this.css;
    };
    RadioComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.onValueChange = this.onChangeValue.subscribe(function (ret) {
            if (ret) {
                _this.radioOptions.forEach(function (option) {
                    if (option.value == ret) {
                        option.active = true;
                    }
                    else {
                        option.active = false;
                    }
                });
                _this._onClick.emit(ret);
                if (_this.onClick != '') {
                    window[_this.onClick](ret);
                }
            }
        });
        if (this.documentation != "") {
            $(this._el.nativeElement).addClass("sbm-documentation");
        }
    };
    RadioComponent.prototype.ngOnDestroy = function () {
        this.onValueChange.unsubscribe();
    };
    RadioComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: "sbm-radio",
                    template: require('./radio.component.html'),

                    styles: [require('./radio.component.css')],
                    host: {
                        "[class]": "classCss"
                    },
                    providers: [
                        abstract_ngmodel_1.MakeProvider(RadioComponent),
                        {
                            provide: abstract_ngmodel_1.AbstractNgModel,
                            useExisting: core_1.forwardRef(function () { return RadioComponent; })
                        }
                    ]
                },] },
    ];
    /** @nocollapse */
    RadioComponent.ctorParameters = function () { return [
        { type: core_1.ElementRef, },
        { type: core_2.TranslateService, },
        { type: http_1.Http, },
        { type: sharedService_1.SharedService, },
    ]; };
    RadioComponent.propDecorators = {
        "radioOptions": [{ type: core_1.ContentChildren, args: [core_1.forwardRef(function () { return radio_option_component_1.RadioOptions; }),] },],
        "component": [{ type: core_1.ViewChild, args: ["component",] },],
        "dataSource": [{ type: core_1.Input },],
        "_onClick": [{ type: core_1.Output },],
        "onClick": [{ type: core_1.Input },],
        "notnull": [{ type: core_1.Input, args: ["require",] },],
        "textAlign": [{ type: core_1.Input },],
        "height": [{ type: core_1.Input },],
        "showborder": [{ type: core_1.Input },],
        "showlabel": [{ type: core_1.Input },],
    };
    return RadioComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.RadioComponent = RadioComponent;
var RadioEnumOrientation;
(function (RadioEnumOrientation) {
    RadioEnumOrientation[RadioEnumOrientation["horizontal"] = 0] = "horizontal";
    RadioEnumOrientation[RadioEnumOrientation["vertical"] = 1] = "vertical";
})(RadioEnumOrientation = exports.RadioEnumOrientation || (exports.RadioEnumOrientation = {}));
