import { AfterViewInit, OnInit } from '@angular/core';
import { FormBuilder, FormGroup } from '@angular/forms';
import { ReqHttpService } from '../../services/req-http.service';
import { TabsComponent } from '../tabs/tabs.component';
import { TabComponent } from '../tabs/tab.component';
import { SharedService } from '../../models/sharedService';
import { CheckboxComponent } from '../checkbox/checkbox.component';
import { MultiselectComponent } from "../multiselect/multiselect.component";
export declare class SchedulingComponent implements OnInit, AfterViewInit {
    private fb;
    private _http;
    private _sharedService;
    private timesFormSubmitSubscribe;
    private processFormSubmitSubscribe;
    isReport: boolean;
    showAgendamento: boolean;
    colProcessos: any;
    emailsSucesso: string[];
    emailsFalha: string[];
    multiselectvalue2: any;
    multiselectvalue: any;
    schedulingServer: any;
    processResult: any[];
    processesValid: boolean;
    timesValid: boolean;
    scheduleValid: boolean;
    schedules: any;
    ativo: boolean;
    withShadingOptionsVisible: boolean;
    btn_salvar: string;
    bloqBotao: boolean;
    form: FormGroup;
    tabs: TabsComponent;
    tabAgendamento: TabComponent;
    tabProcessos: TabComponent;
    tabHorarios: TabComponent;
    multiselectsucesso: MultiselectComponent;
    multiselectfalha: MultiselectComponent;
    checkbox: CheckboxComponent;
    constructor(fb: FormBuilder, _http: ReqHttpService, _sharedService: SharedService);
    saveSchedule(): void;
    subscribeTimesFormSubmit(): void;
    subscribeProcessFormSubmit(): void;
    ngAfterViewInit(): void;
    buscaAgendamentoEdit(): void;
    carregaAgendamentoEdit(scheduling: any): void;
    orderExecution(data: any): void;
    changeOrderProcess(data: any, process: any): void;
    clickActive(data: any): void;
    toggleWithShadingOptions(): void;
    openSchedule(): void;
    removeProcess(data: any): void;
    removeSchedulesMounth(data: any): void;
    removeSchedulesWeek(data: any): void;
    removeSchedulesTemporary(data: any): void;
    removeSchedulesOnly(data: any): void;
    ngOnInit(): void;
    ngAfterContentChecked(): void;
    iniciar(): void;
}
