import { OnInit, TemplateRef, ViewContainerRef } from '@angular/core';
import { AbstractNgModel } from '../../models/abstract.ngmodel';
import { TranslateService } from '@ngx-translate/core';
import { SharedService } from '../../models/sharedService';
import { Http } from '@angular/http';
export declare class TabComponent extends AbstractNgModel implements OnInit {
    private _viewContainerRef;
    private _translateService;
    _http: Http;
    private _sharedService;
    constructor(_viewContainerRef: ViewContainerRef, _translateService: TranslateService, _http: Http, _sharedService: SharedService);
    align: string;
    icon: string;
    halign: string;
    valign: string;
    hidden: boolean;
    _btnClose: any;
    btnClose: any;
    internalColumnTemplate: TemplateRef<any>;
    tabContainer: any;
    tabContainerRow: any;
    tabErrorContainer: ViewContainerRef;
    test: any;
    idGerenarated: any;
    ngOnInit(): void;
    ngAfterViewInit(): void;
}
