import { AfterViewInit, ElementRef, EventEmitter, QueryList, Renderer2, TemplateRef, ComponentFactoryResolver } from '@angular/core';
import { TabComponent } from './tab.component';
export declare class TabsComponent implements AfterViewInit {
    private elRef;
    private _renderer;
    private _componentFactoryResolver;
    constructor(elRef: ElementRef, _renderer: Renderer2, _componentFactoryResolver: ComponentFactoryResolver);
    el: HTMLElement;
    tabsContent: ElementRef;
    ul: any;
    css: string;
    layout: string;
    padding: string;
    closeButton: boolean;
    onTabClick: EventEmitter<{}>;
    onAfterViewInit: EventEmitter<{}>;
    onSelectedTab: EventEmitter<{}>;
    onRemoveTab: EventEmitter<{}>;
    selectedIndex: any;
    tabsDinamic: any[];
    _columns: any;
    columns: any;
    tabs: QueryList<TabComponent>;
    ngAfterViewInit(): void;
    removeDinamic(event: any, tab: any): void;
    selectedTab(tab: any): void;
    addTab(label: string, disabled?: any, isActive?: any, content?: TemplateRef<any>): void;
    selectTab(tab: TabComponent): void;
}
