"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var TimelineContainerComponent = /** @class */ (function () {
    function TimelineContainerComponent() {
    }
    TimelineContainerComponent.prototype.ngOnInit = function () { };
    TimelineContainerComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-timeline-container',
                    template: require('./timeline-container.component.html'),

                    styles: [require('./timeline-container.component.css')],
               },] },
    ];
    /** @nocollapse */
    TimelineContainerComponent.ctorParameters = function () { return []; };
    TimelineContainerComponent.propDecorators = {
        "timelineTemplate": [{ type: core_1.ViewChild, args: ["timelineTemplate",] },],
    };
    return TimelineContainerComponent;
}());
exports.TimelineContainerComponent = TimelineContainerComponent;
var TimelineTitleComponent = /** @class */ (function () {
    function TimelineTitleComponent() {
    }
    TimelineTitleComponent.prototype.ngOnInit = function () { };
    TimelineTitleComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: "sbm-timeline-title",
                    template: "<h4 class=\"timeline-title {{css}}\"><ng-content></ng-content></h4>"
                },] },
    ];
    /** @nocollapse */
    TimelineTitleComponent.ctorParameters = function () { return []; };
    TimelineTitleComponent.propDecorators = {
        "css": [{ type: core_1.Input },],
    };
    return TimelineTitleComponent;
}());
exports.TimelineTitleComponent = TimelineTitleComponent;
var TimelineEventomponent = /** @class */ (function () {
    function TimelineEventomponent() {
        this.css = '';
    }
    TimelineEventomponent.prototype.ngOnInit = function () { };
    TimelineEventomponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: "sbm-timeline-event",
                    template: "<ng-content></ng-content>",
                    host: {
                        '[class]': 'css'
                    }
                },] },
    ];
    /** @nocollapse */
    TimelineEventomponent.ctorParameters = function () { return []; };
    TimelineEventomponent.propDecorators = {
        "css": [{ type: core_1.Input },],
    };
    return TimelineEventomponent;
}());
exports.TimelineEventomponent = TimelineEventomponent;
var TimelineImgComponent = /** @class */ (function () {
    function TimelineImgComponent() {
        this.css = '';
    }
    TimelineImgComponent.prototype.ngOnInit = function () { };
    TimelineImgComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: "sbm-timeline-img",
                    template: "<img [class]=\"css\" [src]=\"src\" [alt]=\"alt\">"
                },] },
    ];
    /** @nocollapse */
    TimelineImgComponent.ctorParameters = function () { return []; };
    TimelineImgComponent.propDecorators = {
        "src": [{ type: core_1.Input },],
        "alt": [{ type: core_1.Input },],
        "css": [{ type: core_1.Input },],
    };
    return TimelineImgComponent;
}());
exports.TimelineImgComponent = TimelineImgComponent;
var TimelineContentComponent = /** @class */ (function () {
    function TimelineContentComponent() {
        this.css = '';
    }
    TimelineContentComponent.prototype.ngOnInit = function () { };
    TimelineContentComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: "sbm-timeline-content",
                    template: "<p [class]=\"css\"><ng-content></ng-content></p>"
                },] },
    ];
    /** @nocollapse */
    TimelineContentComponent.ctorParameters = function () { return []; };
    TimelineContentComponent.propDecorators = {
        "css": [{ type: core_1.Input },],
    };
    return TimelineContentComponent;
}());
exports.TimelineContentComponent = TimelineContentComponent;
var TimelineActionComponent = /** @class */ (function () {
    function TimelineActionComponent() {
    }
    TimelineActionComponent.prototype.ngOnInit = function () { };
    TimelineActionComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: "sbm-timeline-action",
                    template: ""
                },] },
    ];
    /** @nocollapse */
    TimelineActionComponent.ctorParameters = function () { return []; };
    return TimelineActionComponent;
}());
exports.TimelineActionComponent = TimelineActionComponent;
