"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var http_1 = require("@angular/http");
var sharedService_1 = require("../../models/sharedService");
var core_2 = require("@ngx-translate/core");
var UploadImageComponent = /** @class */ (function (_super) {
    __extends(UploadImageComponent, _super);
    function UploadImageComponent(_sharedService, _translateService, _http) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._sharedService = _sharedService;
        _this._translateService = _translateService;
        _this._http = _http;
        _this.url = '';
        _this.base64 = [];
        _this.id = '';
        _this.securityId = '';
        _this.attribute = '';
        _this._columns = '';
        return _this;
    }
    UploadImageComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
    };
    Object.defineProperty(UploadImageComponent.prototype, "imgsrc", {
        get: function () {
            return this.imgValue;
        },
        set: function (value) {
            this.imgValue = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UploadImageComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "" + value;
        },
        enumerable: true,
        configurable: true
    });
    UploadImageComponent.prototype.uploadFileTeste = function ($event) {
        if ($event.data[0].type.indexOf('image') > -1 && $event.value != "") {
            this.imgValue = 'data:';
            this.imgValue += $event.data[0].type;
            this.imgValue += ';base64,';
            this.imgValue += $event.value;
        }
        else {
            this.imgValue = '';
            this.base64 = '';
        }
    };
    UploadImageComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-upload-image',
                    template: require('./upload-image.component.html'),

                    providers: [
                        abstract_ngmodel_1.MakeProvider(UploadImageComponent),
                        { provide: abstract_ngmodel_1.AbstractNgModel, useExisting: core_1.forwardRef(function () { return UploadImageComponent; }) }
                    ]
                },] },
    ];
    /** @nocollapse */
    UploadImageComponent.ctorParameters = function () { return [
        { type: sharedService_1.SharedService, },
        { type: core_2.TranslateService, },
        { type: http_1.Http, },
    ]; };
    UploadImageComponent.propDecorators = {
        "imgsrc": [{ type: core_1.Input },],
        "id": [{ type: core_1.Input },],
        "securityId": [{ type: core_1.Input },],
        "attribute": [{ type: core_1.Input },],
        "columns": [{ type: core_1.Input },],
    };
    return UploadImageComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.UploadImageComponent = UploadImageComponent;
