import { Subscription } from 'rxjs/Subscription';
import { ElementRef, EventEmitter, OnInit } from '@angular/core';
import { AbstractNgModel } from '../../models/abstract.ngmodel';
import { IComponentDefault } from '../../interfaces/IComponentDefault';
import { SharedService } from "../../models/sharedService";
import { Http } from '@angular/http';
import { TranslateService } from "@ngx-translate/core";
export declare class UploadComponent extends AbstractNgModel implements OnInit, IComponentDefault {
    private _sharedService;
    _http: Http;
    private _translateService;
    constructor(_sharedService: SharedService, _http: Http, _translateService: TranslateService);
    file: any;
    input: ElementRef;
    inputFile: ElementRef;
    fileUploader: any;
    _multiple: any;
    multiple: any;
    accept: string;
    dataType: boolean;
    inputValid: boolean;
    msgError: string;
    validationsMsg: any;
    component: any;
    uploadValue: any;
    filesView: any[];
    files: any;
    subscription: Subscription;
    onUpload: EventEmitter<{}>;
    value: any;
    ngOnInit(): void;
    formatarSize(bytes: number): string;
    clearValue(): void;
    changeFile(file: any): void;
    remove(fileInput: any, file: any): void;
}
