"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var MaskDirective = /** @class */ (function () {
    function MaskDirective(sbmMask) {
        var _this = this;
        this.sbmMask = sbmMask;
        this.ret = {
            mask: true
        };
        this.opt = {
            onComplete: function (v) {
                _this.ret = null;
            }
        };
    }
    MaskDirective.prototype.validate = function (c) {
        if (this.ret) {
            return {
                mask: true
            };
        }
        else {
            return this.ret;
        }
    };
    MaskDirective.decorators = [
        { type: core_1.Directive, args: [{
                    selector: '[sbmMask]',
                    providers: [
                        { provide: forms_1.NG_VALIDATORS, useExisting: core_1.forwardRef(function () { return MaskDirective; }), multi: true }
                    ]
                },] },
    ];
    /** @nocollapse */
    MaskDirective.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: core_1.Attribute, args: ['sbmMask',] },] },
    ]; };
    MaskDirective.propDecorators = {
        "mask": [{ type: core_1.Input, args: ['sbmMask',] },],
    };
    return MaskDirective;
}());
exports.MaskDirective = MaskDirective;
