"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var RegExpDirective = /** @class */ (function () {
    function RegExpDirective(sbmRegExp, el) {
        this.sbmRegExp = sbmRegExp;
        this.el = el;
    }
    RegExpDirective.prototype.validate = function (c) {
        if (c.value && this.maskExp) {
            var regexRegExp = new RegExp('^' + this.maskExp + '+$', 'g');
            if (regexRegExp.test(c.value)) {
                return null;
            }
            else {
                return {
                    regExp: true
                };
            }
        }
        return null;
    };
    RegExpDirective.decorators = [
        { type: core_1.Directive, args: [{
                    selector: '[sbmRegExp]',
                    providers: [
                        { provide: forms_1.NG_VALIDATORS, useExisting: core_1.forwardRef(function () { return RegExpDirective; }), multi: true }
                    ]
                },] },
    ];
    /** @nocollapse */
    RegExpDirective.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: core_1.Attribute, args: ['sbmRegExp',] },] },
        { type: core_1.ElementRef, },
    ]; };
    RegExpDirective.propDecorators = {
        "maskExp": [{ type: core_1.Input },],
    };
    return RegExpDirective;
}());
exports.RegExpDirective = RegExpDirective;
