import { ControlValueAccessor } from '@angular/forms';
import { EventEmitter } from '@angular/core';
import 'rxjs/add/operator/map';
import { SharedService } from './sharedService';
import { Http } from '@angular/http';
import { TranslateService } from '@ngx-translate/core';
import { NgModel } from '@angular/forms';
export declare abstract class AbstractNgModel implements ControlValueAccessor {
    _http: Http;
    private innerValue;
    defaultValue: any;
    private onTouchedCallback;
    private onChangeCallback;
    exibirComponente: boolean;
    validationsMsg: any;
    shared: any;
    traducao: any;
    onChangeValue: EventEmitter<{}>;
    translateService: any;
    editField: boolean;
    insertField: boolean;
    constructor(_sharedService: SharedService, _translateService: TranslateService, _http: Http);
    randomId: any;
    isNotMasterDetail: boolean;
    component: NgModel;
    component2: any;
    component3: any;
    id: string;
    securityId: string;
    naturalKey: string;
    css: string;
    styleCss: string;
    index: string;
    icon: string;
    badge: string;
    align: string;
    layout: string;
    name: string;
    placeholder: string;
    textSeparator: string;
    reqIndexKey: string;
    valueField: string;
    color: string;
    textColor: string;
    design: string;
    title: string;
    tooltip: string;
    type: any;
    pattern: string;
    maxLength: string;
    minLength: string;
    object: string;
    indeterminate: boolean;
    bpmn: boolean;
    fullWidth: boolean;
    disabled: boolean;
    notnull: boolean;
    active: boolean;
    custom: boolean;
    private _readonly;
    readonly: boolean;
    onClick: string;
    onBlur: string;
    onKeyup: string;
    onChange: string;
    _onClick: EventEmitter<{}>;
    _onBlur: EventEmitter<{}>;
    _onKeyup: EventEmitter<{}>;
    _onChange: EventEmitter<{}>;
    _onRemove: EventEmitter<{}>;
    private _attribute;
    attribute: string;
    private _documentation;
    documentation: string;
    private _text;
    text: any;
    private privateLabel;
    _label: any;
    label: string;
    _columns: any;
    classCss: any;
    columns: any;
    static makeId(): string;
    validar(securityId: any): void;
    value: any;
    writeValue(value: any): any;
    registerOnChange(fn: any): any;
    registerOnTouched(fn: any): any;
}
export declare function MakeProvider(type: any): any;
