"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var forms_1 = require("@angular/forms");
var core_1 = require("@angular/core");
require("rxjs/add/operator/map");
var i18n_1 = require("./i18n");
var forms_2 = require("@angular/forms");
var noop = function () {
};
var ɵ0 = noop;
exports.ɵ0 = ɵ0;
var AbstractNgModel = /** @class */ (function () {
    function AbstractNgModel(_sharedService, _translateService, _http) {
        var _this = this;
        this._http = _http;
        this.onTouchedCallback = noop;
        this.onChangeCallback = noop;
        this.exibirComponente = false;
        this.validationsMsg = {
            require: null,
            minLength: null,
            maxLength: null,
            notNull: null
        };
        this.onChangeValue = new core_1.EventEmitter();
        this.editField = false;
        this.insertField = false;
        this.randomId = "";
        this.isNotMasterDetail = true;
        this.id = "";
        this.securityId = "";
        this.naturalKey = "";
        this.css = "";
        this.styleCss = "";
        this.index = "";
        this.icon = "";
        this.badge = "";
        this.align = "";
        this.layout = "";
        this.placeholder = "Digite aqui";
        this.textSeparator = "-";
        this.reqIndexKey = "data";
        this.valueField = "";
        this.color = "";
        this.textColor = "black-text";
        this.design = "";
        this.title = "";
        this.pattern = "";
        this.maxLength = "";
        this.minLength = "";
        this.object = null;
        this.bpmn = false;
        this.fullWidth = false;
        this.disabled = false;
        this.notnull = false;
        this.active = false;
        this.custom = false;
        this._readonly = false;
        // eventos js
        this.onClick = "";
        this.onBlur = "";
        this.onKeyup = "";
        this.onChange = "";
        // eventos ts
        this._onClick = new core_1.EventEmitter();
        this._onBlur = new core_1.EventEmitter();
        this._onKeyup = new core_1.EventEmitter();
        this._onChange = new core_1.EventEmitter();
        this._onRemove = new core_1.EventEmitter();
        this._attribute = "";
        this._documentation = "";
        // propriedade para mostrar mais que campo do objeto passado no dataSource
        this._text = [];
        this._label = "";
        // colunas dos componentes
        this._columns = "col l12 m12 s12 crud-form-dynamic";
        this.classCss = "col l12 m12 s12 crud-form-dynamic";
        this.shared = _sharedService;
        _translateService.onLangChange.subscribe(function (event) {
            var retTraducao = _sharedService.getTraducao("sabium-framework")[0];
            _this.validationsMsg["notNull"] = retTraducao["validation.notNull"];
            _this.validationsMsg["minLength"] = retTraducao["validation.minLength"].replace("%", _this.minLength);
            _this.validationsMsg["maxLength"] = retTraducao["validation.maxLength"].replace("%", _this.maxLength);
        });
        this.traducao = new i18n_1.i18n(_translateService, _sharedService);
        this.traducao.projectName = "sabium-framework";
        this.traducao.iniciarIdioma();
        this.translateService = _translateService;
        this.randomId = AbstractNgModel.makeId();
        sbmAbstractModel.push(this);
    }
    Object.defineProperty(AbstractNgModel.prototype, "readonly", {
        get: function () {
            return this._readonly;
        },
        set: function (val) {
            if (val) {
                this.notnull = false;
                this._readonly = true;
            }
            else {
                this._readonly = true;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AbstractNgModel.prototype, "attribute", {
        get: function () {
            return this._attribute;
        },
        set: function (val) {
            this._attribute = val;
            this.name = val;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AbstractNgModel.prototype, "documentation", {
        get: function () {
            return this._documentation;
        },
        set: function (val) {
            if (val != "") {
                if (val.substring(0, 4) == "i18n") {
                    this._documentation = this.translateService.translations[this.translateService.currentLang].i18n["sabium-framework"][val.replace("i18n.", "")];
                }
                else if (val.substring(0, 1) == "#") {
                    if (_projectName) {
                        this._documentation = this.translateService.translations[this.translateService.currentLang].i18n[_projectName][val.replace("#", "")];
                    }
                    else {
                        this._documentation = val;
                    }
                }
                else {
                    this._documentation = val;
                }
                this.columns = +"sbm-documentation";
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AbstractNgModel.prototype, "text", {
        get: function () {
            return this._text;
        },
        set: function (val) {
            if (typeof val == "object") {
                this._text = val;
            }
            else if (typeof val == "string") {
                this._text = val.split(",");
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AbstractNgModel.prototype, "label", {
        get: function () {
            return this.privateLabel;
        },
        set: function (val) {
            this.privateLabel = val;
            if (val.substring(0, 4) == "i18n") {
                this._label = this.translateService.translations[this.translateService.currentLang].i18n["sabium-framework"][val.replace("i18n.", "")];
            }
            else if (val.substring(0, 1) == "#") {
                if (_projectName) {
                    this._label = this.translateService.translations[this.translateService.currentLang].i18n[_projectName][val.replace("#", "")];
                }
                else {
                    this._label = val;
                }
            }
            else {
                this._label = val;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AbstractNgModel.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            if (value) {
                this._columns = "col l" + value + " s12 m12 crud-form-dynamic";
            }
            else {
                this._columns = "col l12 s12 m12 crud-form-dynamic";
            }
            this.classCss = this._columns;
        },
        enumerable: true,
        configurable: true
    });
    // gera uma string randomica
    // gera uma string randomica
    AbstractNgModel.makeId = 
    // gera uma string randomica
    function () {
        var text = "";
        var possibleGenerate = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
        for (var i = 0; i < 14; i++) {
            text += possibleGenerate.charAt(Math.floor(Math.random() * possibleGenerate.length));
        }
        return "sbm-" + text;
    };
    // valida os componetes pelo securityId
    // valida os componetes pelo securityId
    AbstractNgModel.prototype.validar = 
    // valida os componetes pelo securityId
    function (securityId) {
        var _this = this;
        this.exibirComponente = false;
        this.insertField = false;
        this.editField = false;
        if (window.localStorage.getItem("__SBM-STUDIO__/exibirComponente")) {
            this.exibirComponente = true;
            this.insertField = true;
            this.editField = true;
        }
        else {
            if (securityId != "") {
                var _permissoes = this.shared.getLocalStorage(_projectLocalStorage, "permissoes", true);
                if (_permissoes) {
                    // Encontra as permissões do componente atual
                    _permissoes.permissoes.forEach(function (ret) {
                        if ((ret.recursoSeguranca.identificador == securityId)) {
                            ret.tiposAcesso.forEach(function (e) {
                                /*if (e == "LEITURA") {
                                                                    this.exibirComponente = true;
                                                                }*/
                                if (e == "INCLUSAO") {
                                    _this.insertField = true;
                                }
                                if (e == "EDICAO") {
                                    _this.editField = true;
                                }
                            });
                        }
                    });
                }
                else {
                    this.exibirComponente = false;
                    this.insertField = false;
                    this.editField = false;
                }
                if (securityId == "internal") {
                    this.exibirComponente = true;
                    this.insertField = true;
                    this.editField = true;
                }
            }
        }
    };
    Object.defineProperty(AbstractNgModel.prototype, "value", {
        // --ngValueAcessor dos componentes NGMODEL---//
        get: 
        // --ngValueAcessor dos componentes NGMODEL---//
        function () {
            return this.innerValue;
        },
        set: function (v) {
            if (v !== this.innerValue) {
                this.innerValue = v;
                this.onChangeCallback(v);
                this.onChangeValue.emit(v);
            }
            this.defaultValue = v;
        },
        enumerable: true,
        configurable: true
    });
    AbstractNgModel.prototype.writeValue = function (value) {
        if (value !== this.innerValue) {
            this.innerValue = value;
            this.onChangeValue.emit(value);
        }
    };
    AbstractNgModel.prototype.registerOnChange = function (fn) {
        this.onChangeCallback = fn;
    };
    AbstractNgModel.prototype.registerOnTouched = function (fn) {
        this.onTouchedCallback = fn;
    };
    // ---fim dos métodos controValueAcessor-----//
    AbstractNgModel.propDecorators = {
        "component": [{ type: core_1.ViewChild, args: ["component",] },],
        "component2": [{ type: core_1.ViewChild, args: ["component2",] },],
        "component3": [{ type: core_1.ViewChild, args: ["component3",] },],
        "id": [{ type: core_1.Input },],
        "securityId": [{ type: core_1.Input, args: ["securityid",] },],
        "naturalKey": [{ type: core_1.Input, args: ["naturalkey",] },],
        "css": [{ type: core_1.Input },],
        "styleCss": [{ type: core_1.Input, args: ["stylecss",] },],
        "index": [{ type: core_1.Input },],
        "icon": [{ type: core_1.Input },],
        "badge": [{ type: core_1.Input },],
        "align": [{ type: core_1.Input },],
        "layout": [{ type: core_1.Input },],
        "name": [{ type: core_1.Input },],
        "placeholder": [{ type: core_1.Input },],
        "textSeparator": [{ type: core_1.Input, args: ["textseparator",] },],
        "reqIndexKey": [{ type: core_1.Input },],
        "valueField": [{ type: core_1.Input, args: ["valuefield",] },],
        "color": [{ type: core_1.Input },],
        "textColor": [{ type: core_1.Input, args: ["textcolor",] },],
        "design": [{ type: core_1.Input },],
        "title": [{ type: core_1.Input },],
        "tooltip": [{ type: core_1.Input },],
        "type": [{ type: core_1.Input },],
        "pattern": [{ type: core_1.Input },],
        "maxLength": [{ type: core_1.Input, args: ["maxlength",] },],
        "minLength": [{ type: core_1.Input, args: ["minlength",] },],
        "object": [{ type: core_1.Input, args: ["object",] },],
        "indeterminate": [{ type: core_1.Input },],
        "bpmn": [{ type: core_1.Input },],
        "fullWidth": [{ type: core_1.Input, args: ["fullwidth",] },],
        "disabled": [{ type: core_1.Input },],
        "notnull": [{ type: core_1.Input, args: ["require",] },],
        "active": [{ type: core_1.Input },],
        "custom": [{ type: core_1.Input },],
        "readonly": [{ type: core_1.Input },],
        "onClick": [{ type: core_1.Input, args: ["onclick",] },],
        "onBlur": [{ type: core_1.Input, args: ["onblur",] },],
        "onKeyup": [{ type: core_1.Input, args: ["onkeyup",] },],
        "onChange": [{ type: core_1.Input, args: ["onchange",] },],
        "_onClick": [{ type: core_1.Output },],
        "_onBlur": [{ type: core_1.Output },],
        "_onKeyup": [{ type: core_1.Output },],
        "_onChange": [{ type: core_1.Output },],
        "_onRemove": [{ type: core_1.Output },],
        "attribute": [{ type: core_1.Input },],
        "documentation": [{ type: core_1.Input },],
        "text": [{ type: core_1.Input },],
        "label": [{ type: core_1.Input, args: ["label",] },],
        "columns": [{ type: core_1.Input },],
    };
    return AbstractNgModel;
}());
exports.AbstractNgModel = AbstractNgModel;
function MakeProvider(type) {
    return {
        provide: forms_1.NG_VALUE_ACCESSOR,
        useExisting: core_1.forwardRef(function () { return type; }),
        multi: true
    };
}
exports.MakeProvider = MakeProvider;
