"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var funcoes_component_1 = require("./funcoes.component");
var core_1 = require("@angular/core");
var input_text_component_1 = require("../components/input/input-text/input-text.component");
var input_telefone_component_1 = require("../components/input/input-telefone/input-telefone.component");
var input_password_component_1 = require("../components/input/input-password/input-password.component");
var input_number_component_1 = require("../components/input/input-number/input-number.component");
var input_mask_component_1 = require("../components/input/input-mask/input-mask.component");
var input_cep_component_1 = require("../components/input/input-cep/input-cep.component");
var input_cnpj_component_1 = require("../components/input/input-cnpj/input-cnpj.component");
var input_cpf_component_1 = require("../components/input/input-cpf/input-cpf.component");
var input_email_component_1 = require("../components/input/input-email/input-email.component");
var radio_component_1 = require("../components/radio/radio.component");
var list_view_component_1 = require("../components/list-view/list-view.component");
var datebox_component_1 = require("../components/datebox/datebox.component");
var upload_component_1 = require("../components/upload/upload.component");
var autocomplete_component_1 = require("../components/autocomplete/autocomplete.component");
var checkbox_component_1 = require("../components/checkbox/checkbox.component");
var money_component_1 = require("../components/input/money/money.component");
var textarea_component_1 = require("../components/input/textarea/textarea.component");
var multiselect_component_1 = require("../components/multiselect/multiselect.component");
var select_component_1 = require("../components/select/select.component");
var forms_1 = require("@angular/forms");
var crud_component_1 = require("../components/crud/crud.component");
var abstract_ngmodel_1 = require("./abstract.ngmodel");
var AbstractFormComponents = /** @class */ (function () {
    function AbstractFormComponents() {
        this.formValid = 0;
    }
    AbstractFormComponents.prototype.getObject = function () {
        return this.objectData;
    };
    AbstractFormComponents.prototype.validModels = function () {
        var _this = this;
        var BreakException = {};
        if (this.abstractComp.length > 0) {
            // try {
            this.abstractComp.forEach(function (item, index) {
                if (item['isNotMasterDetail']) {
                    if (item['component'] !== undefined && !item['component']['valid']) {
                        _this.formValid++;
                        document.getElementById(item['randomId']).focus();
                        document.getElementById(item['randomId']).blur();
                    }
                }
            });
            // } catch (e) {
            //     if (e !== BreakException) throw e;
            // }
        }
    };
    AbstractFormComponents.prototype.crudSetValue = function (key, value) {
        if (this.inputTextComp.length > 0) {
            this.inputTextComp.forEach(function (item) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                }
            });
        }
        if (this.inputTextComp.length > 0) {
            this.inputTextComp.forEach(function (item) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                }
            });
        }
        if (this.inputCepComp.length > 0) {
            this.inputCepComp.forEach(function (item) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                }
            });
        }
        if (this.inputPasswordComp.length > 0) {
            this.inputPasswordComp.forEach(function (item) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                }
            });
        }
        if (this.inputCpfComp.length > 0) {
            this.inputCpfComp.forEach(function (item) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                }
            });
        }
        if (this.inputEmailComp.length > 0) {
            this.inputEmailComp.forEach(function (item) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                }
            });
        }
        if (this.inputMaskComp.length > 0) {
            this.inputMaskComp.forEach(function (item) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                }
            });
        }
        if (this.inputNumberComp.length > 0) {
            this.inputNumberComp.forEach(function (item) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                }
            });
        }
        if (this.inputTelefoneComp.length > 0) {
            this.inputTelefoneComp.forEach(function (item) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                }
            });
        }
        if (this.selectComp.length > 0) {
            this.selectComp.forEach(function (item) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    // item.value = JSON.parse(value)
                    // item.value = value
                    item.setValue(value);
                }
            });
        }
        if (this.radioComp.length > 0) {
            this.radioComp.forEach(function (item) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                }
            });
        }
        if (this.listViewComp.length > 0) {
            this.listViewComp.forEach(function (item) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                }
            });
        }
        if (this.dateBoxComp.length > 0) {
            this.dateBoxComp.forEach(function (item) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                }
            });
        }
        if (this.uploadComp.length > 0) {
            this.uploadComp.forEach(function (item) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                }
            });
        }
        if (this.autoCompleteComp.length > 0) {
            this.autoCompleteComp.forEach(function (item) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                }
            });
        }
        if (this.checkBoxComp.length > 0) {
            this.checkBoxComp.forEach(function (item) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                }
            });
        }
        if (this.moneyComp.length > 0) {
            this.moneyComp.forEach(function (item) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                }
            });
        }
        if (this.textareaComp.length > 0) {
            this.textareaComp.forEach(function (item) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                }
            });
        }
        if (this.multiSelectComp.length > 0) {
            this.multiSelectComp.forEach(function (item) {
                if (key == item.attribute && item.isNotMasterDetail) {
                    item.value = value;
                }
            });
        }
    };
    AbstractFormComponents.prototype.reloadModel = function () {
        // clearForm.map((a: any) => {
        //     this.crudSetValue(a, storageValues[a])
        // });
    };
    /*sendFormValid(url, $data: any, saveAndContinue?: any, saveServer?: any) {
        if (saveAndContinue) {
            let _notification = new NotificationComponent();
            let _data = [];
            _data.push($data.value);
            this._reqHttpService.xhrPost(`/sabium/api/${url}`, _data).subscribe((ret) => {
                _notification.show(`Sucesso ao salvar o registro`, 2000);
                $data.reset();
                // this.reloadModel();
            });
        }else {
            let _notification = new NotificationComponent();
            let _data = [];
            _data.push($data.value);
            this._reqHttpService.xhrPost(`/sabium/api/${url}`, _data).subscribe((ret) => {
                _notification.show(`Sucesso ao salvar o registro`, 2000);
                $data.reset();
                // this.reloadModel();
            });
        }
    }*/
    /*sendFormValid(url, $data: any, saveAndContinue?: any, saveServer?: any) {
            if (saveAndContinue) {
                let _notification = new NotificationComponent();
                let _data = [];
                _data.push($data.value);
                this._reqHttpService.xhrPost(`/sabium/api/${url}`, _data).subscribe((ret) => {
                    _notification.show(`Sucesso ao salvar o registro`, 2000);
                    $data.reset();
                    // this.reloadModel();
                });
            }else {
                let _notification = new NotificationComponent();
                let _data = [];
                _data.push($data.value);
                this._reqHttpService.xhrPost(`/sabium/api/${url}`, _data).subscribe((ret) => {
                    _notification.show(`Sucesso ao salvar o registro`, 2000);
                    $data.reset();
                    // this.reloadModel();
                });
            }
        }*/
    AbstractFormComponents.prototype.setFormControl = /*sendFormValid(url, $data: any, saveAndContinue?: any, saveServer?: any) {
            if (saveAndContinue) {
                let _notification = new NotificationComponent();
                let _data = [];
                _data.push($data.value);
                this._reqHttpService.xhrPost(`/sabium/api/${url}`, _data).subscribe((ret) => {
                    _notification.show(`Sucesso ao salvar o registro`, 2000);
                    $data.reset();
                    // this.reloadModel();
                });
            }else {
                let _notification = new NotificationComponent();
                let _data = [];
                _data.push($data.value);
                this._reqHttpService.xhrPost(`/sabium/api/${url}`, _data).subscribe((ret) => {
                    _notification.show(`Sucesso ao salvar o registro`, 2000);
                    $data.reset();
                    // this.reloadModel();
                });
            }
        }*/
    function ($object, item) {
        var attrsField = {
            id: item.id,
            attribute: item.attribute,
            value: item.value,
            valid: item.component !== undefined ? item.component.valid : false
        };
        $object.control.addControl(attrsField.attribute, new forms_1.FormControl(null));
        $object.controls[attrsField.attribute].setValue(attrsField.value);
    };
    AbstractFormComponents.prototype.addFormControls = function ($object, saveAndContinue) {
        var _this = this;
        if (this.abstractComp.length > 0) {
            this.abstractComp.forEach(function (item) {
                if (item.isNotMasterDetail) {
                    if (item['component'] !== undefined && !item['component']['valid']) {
                        _this.formValid = item['component']['valid'];
                    }
                    _this.setFormControl($object, item);
                }
            });
        }
        this.sendForm($object, saveAndContinue, true);
    };
    AbstractFormComponents.prototype.sendForm = function ($data, saveAndContinue, saveServer) {
        this.formValid = 0;
        this.validModels();
        if ($data.valid && this.formValid == 0) {
            this.objectData = $data.value;
        }
    };
    AbstractFormComponents.prototype.submited = function () {
        this.componentsForm.forEach(function (item) {
            document.getElementById(item['randomId']).focus();
            document.getElementById(item['randomId']).blur();
        });
    };
    AbstractFormComponents.prototype.initForm = function () {
        var _this = this;
        var elements = {};
        this.componentsForm.forEach(function (item) {
            elements[item.name] = new forms_1.FormControl(item.value, funcoes_component_1.FuncoesComponent.customValidation(item));
            item.onChangeValue.subscribe(function (val) {
                var formCtrl = {};
                formCtrl[item.name] = val;
                _this.formGroup.patchValue(formCtrl);
            });
        });
        this.formGroup = new forms_1.FormGroup(elements);
    };
    AbstractFormComponents.propDecorators = {
        "inputTextComp": [{ type: core_1.ContentChildren, args: [input_text_component_1.InputTextComponent, { descendants: true },] },],
        "inputTelefoneComp": [{ type: core_1.ContentChildren, args: [input_telefone_component_1.InputTelefoneComponent, { descendants: true },] },],
        "inputPasswordComp": [{ type: core_1.ContentChildren, args: [input_password_component_1.InputPasswordComponent, { descendants: true },] },],
        "inputNumberComp": [{ type: core_1.ContentChildren, args: [input_number_component_1.InputNumberComponent, { descendants: true },] },],
        "inputMaskComp": [{ type: core_1.ContentChildren, args: [input_mask_component_1.InputMaskComponent, { descendants: true },] },],
        "inputCepComp": [{ type: core_1.ContentChildren, args: [input_cep_component_1.InputCepComponent, { descendants: true },] },],
        "inputCnpjComp": [{ type: core_1.ContentChildren, args: [input_cnpj_component_1.InputCnpjComponent, { descendants: true },] },],
        "inputCpfComp": [{ type: core_1.ContentChildren, args: [input_cpf_component_1.InputCpfComponent, { descendants: true },] },],
        "inputEmailComp": [{ type: core_1.ContentChildren, args: [input_email_component_1.InputEmailComponent, { descendants: true },] },],
        "radioComp": [{ type: core_1.ContentChildren, args: [radio_component_1.RadioComponent, { descendants: true },] },],
        "listViewComp": [{ type: core_1.ContentChildren, args: [list_view_component_1.ListViewComponent, { descendants: true },] },],
        "dateBoxComp": [{ type: core_1.ContentChildren, args: [datebox_component_1.DateboxComponent, { descendants: true },] },],
        "uploadComp": [{ type: core_1.ContentChildren, args: [upload_component_1.UploadComponent, { descendants: true },] },],
        "autoCompleteComp": [{ type: core_1.ContentChildren, args: [autocomplete_component_1.AutocompleteComponent, { descendants: true },] },],
        "checkBoxComp": [{ type: core_1.ContentChildren, args: [checkbox_component_1.CheckboxComponent, { descendants: true },] },],
        "moneyComp": [{ type: core_1.ContentChildren, args: [money_component_1.MoneyComponent, { descendants: true },] },],
        "textareaComp": [{ type: core_1.ContentChildren, args: [textarea_component_1.TextareaComponent, { descendants: true },] },],
        "multiSelectComp": [{ type: core_1.ContentChildren, args: [multiselect_component_1.MultiselectComponent, { descendants: true },] },],
        "selectComp": [{ type: core_1.ContentChildren, args: [select_component_1.SelectComponent, { descendants: true },] },],
        "crudFormComponent": [{ type: core_1.ContentChildren, args: [core_1.forwardRef(function () { return crud_component_1.CrudFormComponent; }), { descendants: true },] },],
        "abstractComp": [{ type: core_1.ContentChildren, args: [abstract_ngmodel_1.AbstractNgModel, { descendants: true },] },],
        "componentsForm": [{ type: core_1.ContentChildren, args: [abstract_ngmodel_1.AbstractNgModel, { descendants: true },] },],
    };
    return AbstractFormComponents;
}());
exports.AbstractFormComponents = AbstractFormComponents;
