import { LocalStorageService } from "ngx-webstorage";
import { WebSqlService } from "../services/web-sql.service";
export declare class SharedService {
    private _localStorageService;
    private _webSqlService;
    constructor(_localStorageService: LocalStorageService, _webSqlService: WebSqlService);
    getLocalStorage(project: string, key: string, decrypt?: boolean): any;
    getLocalStorageShared(key: string, decrypt?: boolean): any;
    setLocalStorage(project: string, key: string, data: any, criptografar?: boolean): void;
    setLocalStorageShared(key: string, data: any, criptografar?: boolean): void;
    clearLocalStorage(vlr: any): void;
    getIdioma(): any;
    setIdioma(vlr: any): void;
    getTema(): any;
    setTema(vlr: any): void;
    getDispositivoMobile(): any;
    setDispositivoMobile(): void;
    getTraducao(appName: string): any;
    setTraducao(appName: string, vlr: any): void;
    getTempoOciosoAPP(appName: string): any;
    setTempoOciosoAPP(appName: string, vlr: boolean): void;
    duplicarColecao(oldArray: Object[]): any;
    formataTitulo(text: any): any;
}
