"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var MaskTelefonePipe = /** @class */ (function () {
    function MaskTelefonePipe() {
    }
    MaskTelefonePipe.prototype.transform = function (numero) {
        // Remove os caracteres especiais e letras
        var valorNumerico = numero.toString().trim().replace(/[^0-9]/g, '');
        // (dd)
        if (valorNumerico.length > 2 && valorNumerico.length < 6) {
            return ('(' + valorNumerico.slice(0, 2) + ') ' + valorNumerico.slice(2)).trim();
        }
        // (dd) ####-
        if (valorNumerico.length > 5 && valorNumerico.length < 10) {
            return ('(' + valorNumerico.slice(0, 2) + ') ' + valorNumerico.slice(2, 6) + '-' + valorNumerico.slice(6)).trim();
        }
        // (dd) ####-####
        if (valorNumerico.length === 10) {
            return ('(' + valorNumerico.slice(0, 2) + ') ' + valorNumerico.slice(2, 6) + '-' + valorNumerico.slice(6, 10)).trim();
        }
        // (dd) #####-####
        if (valorNumerico.length === 11) {
            return ('(' + valorNumerico.slice(0, 2) + ') ' + valorNumerico.slice(2, 7) + '-' + valorNumerico.slice(7, 11)).trim();
        }
    };
    MaskTelefonePipe.decorators = [
        { type: core_1.Pipe, args: [{
                    name: 'maskTelefone'
                },] },
    ];
    /** @nocollapse */
    MaskTelefonePipe.ctorParameters = function () { return []; };
    return MaskTelefonePipe;
}());
exports.MaskTelefonePipe = MaskTelefonePipe;
