import 'rxjs/Rx';
import { Router } from '@angular/router';
import { SharedService } from '../models/sharedService';
import { WebSqlService } from './web-sql.service';
export declare class ReqHttpService {
    private _router;
    private _sharedService;
    private _webSqlService;
    constructor(_router: Router, _sharedService: SharedService, _webSqlService: WebSqlService);
    isLoggedIn(): boolean;
    salvarToken(token: string): void;
    xhrGet(url: string, timeout?: number): any;
    xhrPost(url: string, params?: any, timeout?: number): any;
    xhrPut(url: string, params: any, timeout?: number): any;
    xhrDelete(url: string, params?: any, timeout?: number): any;
    xhrDownload(url: string, params?: any, timeout?: number): any;
}
