import { TemplateRef } from '@angular/core';
import { AbstractNgModel } from '../../models/abstract.ngmodel';
import { TranslateService } from '@ngx-translate/core';
import { SharedService } from '../../models/sharedService';
import { Http } from "@angular/http";
export declare class AccordionGroupComponent extends AbstractNgModel {
    private _translateService;
    _http: Http;
    private _sharedService;
    constructor(_translateService: TranslateService, _http: Http, _sharedService: SharedService);
    internalColumnTemplate: TemplateRef<any>;
    idAccordion: any;
    hidden: any;
    ngAfterViewInit(): void;
    ngOnInit(): void;
}
export declare enum AccordionEnum {
    primary = 0,
    success = 1,
    warning = 2,
    info = 3,
    danger = 4,
    default = 5,
}
