"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../models/sharedService");
var http_1 = require("@angular/http");
var AccordionGroupComponent = /** @class */ (function (_super) {
    __extends(AccordionGroupComponent, _super);
    function AccordionGroupComponent(_translateService, _http, _sharedService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._sharedService = _sharedService;
        _this.idAccordion = '';
        _this.hidden = false;
        return _this;
    }
    AccordionGroupComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        $(document).ready(function () {
            if (_this.layout == 'vertical') {
                var nElement = _this.internalColumnTemplate['_projectedViews'][0].nodes[2].renderText.parentNode;
                var copyChildren = $.extend(true, {}, nElement.children);
                nElement.innerHTML = "";
                for (var j = 0; j < copyChildren.length; j++) {
                    var linhaRow = document.createElement('div');
                    linhaRow.setAttribute("class", "row");
                    linhaRow.appendChild(copyChildren[j]);
                    nElement.appendChild(linhaRow);
                }
            }
        });
    };
    AccordionGroupComponent.prototype.ngOnInit = function () {
        this.idAccordion = "[index=" + this.index + "]";
        _super.prototype.validar.call(this, this.securityId);
        // this.idAccordion = 'sbm-accordion-' + Math.floor((Math.random() * 1000) + 1);
    };
    AccordionGroupComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-accordion-group',
                    template: require('./accordion-group.component.html'),

                    host: {
                        '[hidden]': '!exibirComponente'
                    }
                },] },
    ];
    /** @nocollapse */
    AccordionGroupComponent.ctorParameters = function () { return [
        { type: core_2.TranslateService, },
        { type: http_1.Http, },
        { type: sharedService_1.SharedService, },
    ]; };
    AccordionGroupComponent.propDecorators = {
        "internalColumnTemplate": [{ type: core_1.ViewChild, args: ['internalColumnTemplate',] },],
        "hidden": [{ type: core_1.Input },],
    };
    return AccordionGroupComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.AccordionGroupComponent = AccordionGroupComponent;
var AccordionEnum;
(function (AccordionEnum) {
    AccordionEnum[AccordionEnum["primary"] = 0] = "primary";
    AccordionEnum[AccordionEnum["success"] = 1] = "success";
    AccordionEnum[AccordionEnum["warning"] = 2] = "warning";
    AccordionEnum[AccordionEnum["info"] = 3] = "info";
    AccordionEnum[AccordionEnum["danger"] = 4] = "danger";
    AccordionEnum[AccordionEnum["default"] = 5] = "default";
})(AccordionEnum = exports.AccordionEnum || (exports.AccordionEnum = {}));
