import { ElementRef, OnInit, QueryList } from '@angular/core';
import { AccordionGroupComponent } from './accordion-group.component';
import { IComponentDefault } from '../../interfaces/IComponentDefault';
import { AbstractNgModel } from '../../models/abstract.ngmodel';
import { TranslateService } from '@ngx-translate/core';
import { SharedService } from '../../models/sharedService';
import { Http } from '@angular/http';
export declare class AccordionComponent extends AbstractNgModel implements IComponentDefault, OnInit {
    private _translateService;
    _http: Http;
    private _sharedService;
    constructor(_translateService: TranslateService, _http: Http, _sharedService: SharedService);
    accordions: QueryList<AccordionGroupComponent>;
    accordion: ElementRef;
    elAccordions: ElementRef;
    randomClass: number;
    ngOnInit(): void;
    clickItem(item: any): void;
    ngAfterViewInit(): void;
}
