"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var accordion_group_component_1 = require("./accordion-group.component");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../models/sharedService");
var http_1 = require("@angular/http");
var AccordionComponent = /** @class */ (function (_super) {
    __extends(AccordionComponent, _super);
    function AccordionComponent(_translateService, _http, _sharedService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._sharedService = _sharedService;
        _this.randomClass = 0;
        sbmAccordionComponent.push(_this);
        return _this;
    }
    AccordionComponent.prototype.ngOnInit = function () {
        this.randomClass = Math.floor((Math.random() * 1000) + 1);
        _super.prototype.validar.call(this, this.securityId);
        this.css = 'sbm-panel-group';
        this.classCss += ' ' + this.css;
    };
    AccordionComponent.prototype.clickItem = function (item) {
        this._onClick.emit(item);
        if (this.onClick != '') {
            window[this.onClick](item);
        }
    };
    AccordionComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        $(document).ready(function () {
            $(_this.accordion.nativeElement).collapsible();
        });
    };
    AccordionComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-accordion',
                    template: require('./accordion.component.html'),

                    host: {
                        '[class]': 'classCss'
                    }
                },] },
    ];
    /** @nocollapse */
    AccordionComponent.ctorParameters = function () { return [
        { type: core_2.TranslateService, },
        { type: http_1.Http, },
        { type: sharedService_1.SharedService, },
    ]; };
    AccordionComponent.propDecorators = {
        "accordions": [{ type: core_1.ContentChildren, args: [core_1.forwardRef(function () { return accordion_group_component_1.AccordionGroupComponent; }),] },],
        "accordion": [{ type: core_1.ViewChild, args: ['accordion',] },],
        "elAccordions": [{ type: core_1.ViewChild, args: ['elAccordions',] },],
    };
    return AccordionComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.AccordionComponent = AccordionComponent;
