import { OnInit } from '@angular/core';
import { Router } from '@angular/router';
import { ReqHttpService } from '../../services/req-http.service';
import { SharedService } from '../../models/sharedService';
import { LocalStorageService } from "ngx-webstorage";
export declare class BookmarkComponent implements OnInit {
    private router;
    private _reqService;
    private _sharedService;
    private _ls;
    isBookmarked: boolean;
    constructor(router: Router, _reqService: ReqHttpService, _sharedService: SharedService, _ls: LocalStorageService);
    app: string;
    versao: string;
    checkActualRouteIsBookmarked(): void;
    verificaRotaFavoritaLocalStorage(actualRoute: any): void;
    onClick($event: any): void;
    addBookmark(): void;
    removeBookmark(): void;
    validaRetornaRota(): string | false;
    updateLocalStorage(route: string, remove: boolean): void;
    ngOnInit(): void;
}
