import { Subscription } from 'rxjs/Subscription';
import { ElementRef, OnInit } from "@angular/core";
import { AbstractNgModel } from "../../models/abstract.ngmodel";
import { TranslateService } from "@ngx-translate/core";
import { Http } from "@angular/http";
import { SharedService } from "../../models/sharedService";
export declare class ColorPickerComponent extends AbstractNgModel implements OnInit {
    private _translateService;
    _http: Http;
    private _sharedService;
    constructor(_translateService: TranslateService, _http: Http, _sharedService: SharedService);
    input: ElementRef;
    value: any;
    subscription: Subscription;
    open: boolean;
    private _color;
    color: any;
    change(color: any): void;
    openColor(): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
}
