import { MatDialog } from '@angular/material';
import { AbstractNgModel } from '../../../models/abstract.ngmodel';
import { QueryList } from '@angular/core';
import { HttpParams } from '@angular/common/http';
import { MasterDetailComponent } from '../../master-detail/master-detail.component';
import { SbmHttpClientService } from '../../../services/sbm-http-client.service';
import { NgForm } from '@angular/forms';
export declare abstract class AbstractCrud {
    sbmHttpClient: SbmHttpClientService;
    dialog: MatDialog;
    constructor(sbmHttpClient: SbmHttpClientService, dialog: MatDialog);
    private abstractComp2;
    masterDetailComp2: QueryList<MasterDetailComponent>;
    private _crudFrom2;
    form: NgForm;
    private abstractDinamic;
    private abstractEntity;
    reqServiceStatus: any[];
    update: any;
    parametersKeyService: HttpParams;
    audit(entity: string, id: any): void;
    static makeId(): string;
    private verificaSeTemPropriedadeObjectNosComponentesEdicao2(data);
    crudSetValue(data: any): void;
    callServiceKey(): void;
    verifNaturalKey(abstractComp: QueryList<AbstractNgModel>, dinamic: any, entity: any): void;
    createFormDinamic(abstractComp: any): void;
}
