import { ElementRef, OnInit } from '@angular/core';
import { AbstractNgModel } from '../../models/abstract.ngmodel';
import { SharedService } from '../../models/sharedService';
import { Http } from '@angular/http';
import { TranslateService } from '@ngx-translate/core';
import { DateTimePickerComponent } from 'ng-pick-datetime/picker.component';
import { Subscription } from 'rxjs/Subscription';
export declare class DatetimeComponent extends AbstractNgModel implements OnInit {
    private el;
    private _sharedService;
    _http: Http;
    private _translateService;
    constructor(el: ElementRef, _sharedService: SharedService, _http: Http, _translateService: TranslateService);
    input: ElementRef;
    picker: any;
    picker2: any;
    mydatepicker: DateTimePickerComponent;
    id: string;
    securityId: string;
    attribute: string;
    css: string;
    styleCss: string;
    currentDay: boolean;
    defaultValue: number;
    disabled: boolean;
    readonly: boolean;
    notnull: any;
    subscriptionValue: Subscription;
    displayFormat: any;
    typeDisplay: any;
    ptBr: {
        firstDayOfWeek: number;
        dayNames: string[];
        dayNamesShort: string[];
        monthNames: string[];
        monthNamesShort: string[];
    };
    valueDisplay: any;
    dateComp: any;
    input1Moment: any;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    blur: (date: any) => void;
    testeBlur(teste: any): void;
    addIcons(): void;
    changeDate(date: any): void;
    oncloseData(date: any): void;
}
