"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var sharedService_1 = require("../../models/sharedService");
var http_1 = require("@angular/http");
var core_2 = require("@ngx-translate/core");
var picker_component_1 = require("ng-pick-datetime/picker.component");
var datebox_component_1 = require("../datebox/datebox.component");
var DatetimeComponent = /** @class */ (function (_super) {
    __extends(DatetimeComponent, _super);
    function DatetimeComponent(el, _sharedService, _http, _translateService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this.el = el;
        _this._sharedService = _sharedService;
        _this._http = _http;
        _this._translateService = _translateService;
        _this.id = '';
        _this.securityId = '';
        _this.attribute = '';
        _this.css = 'sbm-input';
        _this.styleCss = '';
        _this.currentDay = false;
        _this.defaultValue = null;
        _this.disabled = false;
        _this.readonly = false;
        _this.notnull = false;
        _this.displayFormat = datebox_component_1.DateboxConstDisplayFormat.datetime;
        _this.ptBr = {
            firstDayOfWeek: 1,
            dayNames: ['Domingo', 'Segunda', 'Terça', 'Quarta', 'Quinta', 'Sexta', 'Sábado'],
            dayNamesShort: ['Dom', 'Seg', 'Ter', 'Qua', 'Qui', 'Sex', 'Sáb'],
            monthNames: ['Janeiro', 'Fevereiro', 'Março', 'Abril', 'Maio', 'Junho', 'Julho', 'Agosto', 'Setembro', 'Outubro', 'Novembro', 'Dezembro'],
            monthNamesShort: ['Jan', 'Fev', 'Mar', 'Abr', 'Mai', 'Jun', 'Jul', 'Ago', 'Set', 'Out', 'Nov', 'Dez']
        };
        /*blur = (date: any) => {
                //console.log('blur', date);
        
                if(typeof date == 'string'){
                    //if(this.selectionMode == 'single') {
                        if (date && date != '') {
                            let newDate = new Date(date);
        
                            if ( isNaN( newDate.getTime() ) ) {  // d.valueOf() could also work
                                // date is not valid
                                this.dateComp = "";
                                this.value = null;
                                this.valueDisplay = "";
                            }
                            else {
                                // date is valid
                                this.dateComp = newDate;
        
                                this._onChange.emit(newDate);
                                if (this.onChange != '') {
                                    window[this.onChange](newDate);
                                }
                            }
        
                        }else {
                            this.value = null;
                        }
                }
            }*/
        _this.blur = function (date) {
            console.log('blur', date);
        };
        return _this;
    }
    DatetimeComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        $('.owl-dateTime-dialog').css('left', '0px');
    };
    DatetimeComponent.prototype.ngAfterViewInit = function () {
        this.addIcons();
        $(this.input.nativeElement).mask('00/00/0000 00:00');
        this.subscriptionValue = this.onChangeValue.subscribe(function (value) {
            // console.log('96 value  sdadas:', value);
        });
        /*
                * this.changeValue = this.onChangeValue.subscribe((ret) => {
                 $(this.input.nativeElement).mask(this.mask, {clearIfNotMatch: true});
                 this.valueMask = $(this.input.nativeElement).masked(ret);
                 });
                * */
    };
    DatetimeComponent.prototype.testeBlur = function (teste) {
        console.log('testeBlur:', teste);
        console.log(this.input);
        console.log('component', this.component);
        this._onChange.emit(teste);
    };
    /*blur(retorno: any): void {
        this._onBlur.emit(retorno);
    }*/
    /*blur(retorno: any): void {
            this._onBlur.emit(retorno);
        }*/
    DatetimeComponent.prototype.addIcons = /*blur(retorno: any): void {
            this._onBlur.emit(retorno);
        }*/
    function () {
        var upIcon = document.querySelectorAll('owl-date-time .owl-timer-control .icon-up-open');
        var downIcon = document.querySelectorAll('owl-date-time .owl-timer-control .icon-down-open');
        for (var i = 0; i < upIcon.length; i++) {
            upIcon.item(i).innerHTML = '&#xE5CE;';
            upIcon.item(i).classList.toggle('icon');
            upIcon.item(i).classList.toggle('icon-up-open');
            upIcon.item(i).classList.toggle('material-icons');
        }
        for (var i = 0; i < downIcon.length; i++) {
            downIcon.item(i).innerHTML = '&#xE5CF;';
            downIcon.item(i).classList.toggle('icon');
            downIcon.item(i).classList.toggle('icon-up-open');
            downIcon.item(i).classList.toggle('material-icons');
        }
    };
    DatetimeComponent.prototype.changeDate = function (date) {
        // console.log('date:', date);
        // this._onBlur.emit(date);
        // this.valueDisplay = this.value = moment(date).format('DD/MM/YYYY HH:mm');
        // console.log('date', date);
        // if (this.typeDisplay == 'both') {
        // this.valueDisplay = this.value = moment(date).format('DD/MM/YYYY HH:mm');
        // } else if (this.typeDisplay == 'calendar') {
        //  this.valueDisplay = this.value = moment(date).format('DD/MM/YYYY');
        // } else if (this.typeDisplay == 'timer') {
        //  this.valueDisplay = this.value = moment(date).format('HH:mm');
        // }
        /*}else if(this.selectionMode == 'range') {
                    if(date[0] && date[1]) {
                        if (this.typeDisplay == 'both') {
                            this.valueDisplay = this.value = moment(date[0]).format('DD/MM/YYYY HH:mm') +" - "+ moment(date[1]).format('DD/MM/YYYY HH:mm') ;
                        } else if (this.typeDisplay == 'calendar') {
                            this.valueDisplay = this.value = moment(date[0]).format('DD/MM/YYYY') +" - "+ moment(date[1]).format('DD/MM/YYYY');
                        } else if (this.typeDisplay == 'timer') {
                            this.valueDisplay = this.value = moment(date[0]).format('HH:mm') +" - "+ moment(date[1]).format('HH:mm');
                        }
                    }
                }*/
        /*this._onChange.emit(date);
                if (this.onChange != '') {
                    window[this.onChange](date);
                }*/
    };
    DatetimeComponent.prototype.oncloseData = function (date) {
        // console.log('oncloseData', date);
        // console.log('oncloseData component:', this.component);
        // console.log('oncloseData component value:', this.component.value);
        // console.log('getTime:', this.component.value.getTime());
    };
    DatetimeComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-datetime',
                    template: "\n      <mat-form-field class=\"full-width\" [hidden]=\"!exibirComponente\">\n          <input\n              type=\"text\"\n              #datebox\n              #component=\"ngModel\"\n              [(ngModel)]=\"valueDisplay\"\n              [readonly]=\"readonly\"\n              matInput\n          >\n          <owl-date-time \n                         [inputId]=\"'input1'\"\n                         #mydatepicker\n                         dateFormat=\"DD/MM/YYYY HH:mm\"\n                         placeHolder=\"dd/mm/aaaa hh:mm\"\n                         [locale]=\"ptBr\"\n                         (onClose)=\"oncloseData($event)\"\n                         (onBlur)=\"testeBlur($event)\"\n                         [(ngModel)]=\"input1Moment\"                         \n          ></owl-date-time>\n      </mat-form-field>\n  ",
                    host: {
                        '[class]': 'columns',
                        '[ngClass]': 'options ? options.className : ""'
                    },
                    providers: [
                        abstract_ngmodel_1.MakeProvider(DatetimeComponent),
                        { provide: abstract_ngmodel_1.AbstractNgModel, useExisting: core_1.forwardRef(function () { return DatetimeComponent; }) }
                    ]
                },] },
    ];
    /** @nocollapse */
    DatetimeComponent.ctorParameters = function () { return [
        { type: core_1.ElementRef, },
        { type: sharedService_1.SharedService, },
        { type: http_1.Http, },
        { type: core_2.TranslateService, },
    ]; };
    DatetimeComponent.propDecorators = {
        "input": [{ type: core_1.ViewChild, args: ['datebox',] },],
        "picker": [{ type: core_1.ViewChild, args: ['picker',] },],
        "picker2": [{ type: core_1.ViewChild, args: ['picker2',] },],
        "mydatepicker": [{ type: core_1.ViewChild, args: ['mydatepicker',] },],
        "id": [{ type: core_1.Input },],
        "securityId": [{ type: core_1.Input },],
        "attribute": [{ type: core_1.Input },],
        "css": [{ type: core_1.Input },],
        "styleCss": [{ type: core_1.Input },],
        "currentDay": [{ type: core_1.Input, args: ['currentday',] },],
        "defaultValue": [{ type: core_1.Input },],
        "disabled": [{ type: core_1.Input },],
        "readonly": [{ type: core_1.Input },],
        "notnull": [{ type: core_1.Input, args: ['require',] },],
    };
    return DatetimeComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.DatetimeComponent = DatetimeComponent;
