import { AfterViewInit, OnChanges, QueryList, SimpleChanges, TemplateRef } from '@angular/core';
import { NgForm } from '@angular/forms';
import { SbmHttpClientService } from "../../services/sbm-http-client.service";
import { AbstractNgModel } from "../../models/abstract.ngmodel";
import { SharedService } from "../../models/sharedService";
export declare class EntityComponent implements AfterViewInit, OnChanges {
    private service;
    private _sharedService;
    constructor(service: SbmHttpClientService, _sharedService: SharedService);
    inputs: QueryList<AbstractNgModel>;
    form: NgForm;
    entity: string;
    dynamic: string;
    templateButtons: TemplateRef<any>;
    isMasterDetail: boolean;
    onSubmit: any;
    private update;
    reset(): void;
    setValue(data: any): void;
    edit(id: any): void;
    sendRequest(): void;
    sendForm(): void;
    addFormGroup(list: QueryList<AbstractNgModel>): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngAfterViewInit(): void;
}
