"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var material_1 = require("@angular/material");
var parameters_component_1 = require("../../parameters/parameters.component");
var DialogFilterDetail = /** @class */ (function () {
    function DialogFilterDetail(dialog, data) {
        this.dialog = dialog;
        this.data = data;
    }
    DialogFilterDetail.prototype.onNoClick = function () {
        this.dialog.close();
    };
    DialogFilterDetail.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function () {
            _this.parameters.modelParameter = _this.data.row;
        }, 500);
    };
    DialogFilterDetail.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-dialog-master-detail',
                    template: "\n\n        <h5>Detalhes</h5>\n        <hr>\n\n        <sbm-parameters #parameterscomponent1 [dataSource]='data.filtroSaida'></sbm-parameters>\n    ",
                    styles: ["\n        .title-detail {\n            font-size: 14px;\n            font-weight: bold;\n        }\n    "]
                },] },
    ];
    /** @nocollapse */
    DialogFilterDetail.ctorParameters = function () { return [
        { type: material_1.MatDialogRef, },
        { type: undefined, decorators: [{ type: core_1.Inject, args: [material_1.MAT_DIALOG_DATA,] },] },
    ]; };
    DialogFilterDetail.propDecorators = {
        "parameters": [{ type: core_1.ViewChild, args: ['parameterscomponent1',] },],
    };
    return DialogFilterDetail;
}());
exports.DialogFilterDetail = DialogFilterDetail;
