import { Subscription } from 'rxjs';
import { EventEmitter } from '@angular/core';
import { ReqHttpService } from '../../services/req-http.service';
import { AbstractFormComponents } from '../../models/abstractFormComponents';
import { WebSqlService } from "../../services/web-sql.service";
import { IndexedDBService } from "../../services/indexed-db.service";
export declare class FormComponent extends AbstractFormComponents {
    private _reqHttpService;
    private _webSqlService;
    private _indexedDBService;
    constructor(_reqHttpService: ReqHttpService, _webSqlService: WebSqlService, _indexedDBService: IndexedDBService);
    crudForm: any;
    modelsForm: any;
    submit: string;
    reqReturn: string;
    method: any;
    service: any;
    isArray: boolean;
    _submit: EventEmitter<{}>;
    _reqReturn: EventEmitter<{}>;
    noErrosForm: boolean;
    objectFormData: any;
    FormSubscription: Subscription;
    submitForm($data: any): void;
    reqSend(data: any): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
}
