import { ElementRef, OnInit } from '@angular/core';
import { Http } from '@angular/http';
import 'rxjs/add/operator/map';
import { AbstractNgModel } from '../../../models/abstract.ngmodel';
import { IComponentDefault } from '../../../interfaces/IComponentDefault';
import { TranslateService } from '@ngx-translate/core';
import { SharedService } from "../../../models/sharedService";
import { Subscription } from 'rxjs';
export declare class InputCepComponent extends AbstractNgModel implements IComponentDefault, OnInit {
    _http: Http;
    private _el;
    private _sharedService;
    private _translateService;
    constructor(_http: Http, _el: ElementRef, _sharedService: SharedService, _translateService: TranslateService);
    input: ElementRef;
    valueMask: any;
    changeValue: Subscription;
    changeValueEvent(event: any): void;
    msgError: string;
    labelWidth: string;
    inputValid: boolean;
    value: any;
    validationsMsg: any;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    itemClicado(): void;
    blur($event: any): void;
    keyup($event: any): void;
    verificaPadding(): void;
}
