import { ElementRef, OnInit } from "@angular/core";
import { AbstractNgModel } from "../../../models/abstract.ngmodel";
import { IComponentDefault } from "../../../interfaces/IComponentDefault";
import { TranslateService } from '@ngx-translate/core';
import { SharedService } from '../../../models/sharedService';
import { Http } from '@angular/http';
export declare class InputNumberComponent extends AbstractNgModel implements IComponentDefault, OnInit {
    private _translateService;
    _http: Http;
    private _el;
    private _sharedService;
    constructor(_translateService: TranslateService, _http: Http, _el: ElementRef, _sharedService: SharedService);
    input: ElementRef;
    min: string;
    max: string;
    step: string;
    digitAlign: string;
    spinButtons: boolean;
    inputValid: boolean;
    msgError: string;
    dir: string;
    value: any;
    keyup($event: any): void;
    blur($event: any): void;
    ngAfterViewInit(): void;
    ngOnInit(): void;
    verificaPadding(): void;
}
