"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var http_1 = require("@angular/http");
var sharedService_1 = require("../../models/sharedService");
var LabelComponent = /** @class */ (function (_super) {
    __extends(LabelComponent, _super);
    function LabelComponent(_sharedService, _translateService, _http, _el) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._sharedService = _sharedService;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._el = _el;
        _this.align = 'left';
        _this.setValue = function (value) {
            $('#sbm-label-identifier').html(value);
        };
        sbmLabelComponent.push(_this);
        return _this;
    }
    LabelComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        if (this.columns.indexOf('auto') > -1) {
            this._columns = '';
        }
        $(document).ready(function () {
            setTimeout(function () {
                _this.label = _this.labelComp.nativeElement.innerText.trim();
                if (_this.type) {
                    switch (_this.type) {
                        case 'h1':
                            $(_this.labelComp.nativeElement).replaceWith("<h1 id=\"sbm-label-identifier\" class='" + _this.css + "' style='text-align: " + _this.align + ";" + _this.styleCss + "'>" + _this._label + "</h1>");
                            break;
                        case 'h2':
                            $(_this.labelComp.nativeElement).replaceWith("<h2 id=\"sbm-label-identifier\" class='" + _this.css + "' style='text-align: " + _this.align + ";" + _this.styleCss + "'>" + _this._label + "</h2>");
                            break;
                        case 'h3':
                            $(_this.labelComp.nativeElement).replaceWith("<h3 id=\"sbm-label-identifier\" class='" + _this.css + "' style='text-align: " + _this.align + ";" + _this.styleCss + "'>" + _this._label + "</h3>");
                            break;
                        case 'h4':
                            $(_this.labelComp.nativeElement).replaceWith("<h4 id=\"sbm-label-identifier\" class='" + _this.css + "' style='text-align: " + _this.align + ";" + _this.styleCss + "'>" + _this._label + "</h4>");
                            break;
                        case 'h5':
                            $(_this.labelComp.nativeElement).replaceWith("<h5 id=\"sbm-label-identifier\" class='" + _this.css + "' style='text-align: " + _this.align + ";" + _this.styleCss + "'>" + _this._label + "</h5>");
                            break;
                        default:
                            $(_this.labelComp.nativeElement).replaceWith("<span id=\"sbm-label-identifier\" class='" + _this.css + "' style='text-align: " + _this.align + ";" + _this.styleCss + "'>" + _this._label + "</span>");
                            break;
                    }
                }
                else {
                    $(_this.labelComp.nativeElement).replaceWith("<span class='" + _this.css + "' style='text-align: " + _this.align + ";" + _this.styleCss + "'>" + _this._label + "</span>");
                }
            }, 500);
        });
        $(this.labelComp.nativeElement).attr('style', this.styleCss);
    };
    LabelComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
    };
    LabelComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-label',
                    template: require('./label.component.html'),

                    host: {
                        '[class]': 'columns'
                    }
                },] },
    ];
    /** @nocollapse */
    LabelComponent.ctorParameters = function () { return [
        { type: sharedService_1.SharedService, },
        { type: core_2.TranslateService, },
        { type: http_1.Http, },
        { type: core_1.ElementRef, },
    ]; };
    LabelComponent.propDecorators = {
        "labelComp": [{ type: core_1.ViewChild, args: ['label',] },],
        "align": [{ type: core_1.Input },],
    };
    return LabelComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.LabelComponent = LabelComponent;
