"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../models/sharedService");
var http_1 = require("@angular/http");
var ListOptions = /** @class */ (function (_super) {
    __extends(ListOptions, _super);
    function ListOptions(_sharedService, _http, _translateService, _el) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._http = _http;
        _this._translateService = _translateService;
        _this._el = _el;
        _this.idListOption = '';
        _this.value = '';
        return _this;
    }
    ListOptions.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this.idListOption = 'sbm-list-active-' + Math.floor((Math.random() * 100000) + 1);
    };
    ListOptions.prototype.ngAfterViewInit = function () {
        this.label = this._el.nativeElement.textContent.replace(/\s/g, '');
    };
    ListOptions.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'sbm-list-option',
                    template: require('./list-option.component.html'),

                    host: {
                        '[text]': 'value'
                    }
                },] },
    ];
    /** @nocollapse */
    ListOptions.ctorParameters = function () { return [
        { type: sharedService_1.SharedService, },
        { type: http_1.Http, },
        { type: core_2.TranslateService, },
        { type: core_1.ElementRef, },
    ]; };
    ListOptions.propDecorators = {
        "value": [{ type: core_1.Input },],
        "el": [{ type: core_1.ViewChild, args: ['el',] },],
        "columnTemplate": [{ type: core_1.ViewChild, args: ['internalColumnTemplate',] },],
    };
    return ListOptions;
}(abstract_ngmodel_1.AbstractNgModel));
exports.ListOptions = ListOptions;
