import { ElementRef, EventEmitter, OnInit } from '@angular/core';
import { SharedService } from '../../models/sharedService';
import { Http } from '@angular/http';
import { TranslateService } from '@ngx-translate/core';
import { AbstractNgModel } from '../../models/abstract.ngmodel';
export declare class ModalComponent extends AbstractNgModel implements OnInit {
    _http: Http;
    private _translateService;
    constructor(_sharedService: SharedService, _http: Http, _translateService: TranslateService);
    ngOnInit(): void;
    popup: ElementRef;
    showTitle: boolean;
    width: string;
    height: string;
    position: string;
    onClose: string;
    _onClose: EventEmitter<{}>;
    private _title;
    title: string;
    textButton: string;
    _visible: boolean;
    visible: boolean;
    _layout: any;
    layout: any;
    ngAfterViewInit(): void;
    open(): void;
}
