import { OnInit, ElementRef } from '@angular/core';
import { DateboxComponent } from '../datebox/datebox.component';
import 'rxjs/add/operator/toPromise';
import { DxDataGridComponent } from 'devextreme-angular';
import { MatDialog, MatDialogRef } from '@angular/material';
import { ReportComponent } from "../report/report.component";
import { SharedService } from "../../models/sharedService";
import { ScheduleProcessComponent } from "../scheduling/schedule-process.component";
import { ReqHttpService } from "../../services/req-http.service";
export declare class MonitorComponent implements OnInit {
    private _reqHttpService;
    dialog: MatDialog;
    private _sharedService;
    constructor(_reqHttpService: ReqHttpService, dialog: MatDialog, _sharedService: SharedService);
    monitor: DxDataGridComponent;
    datarange: DateboxComponent;
    reportMonitor: ReportComponent;
    processMonitor: ScheduleProcessComponent;
    dbEnumType: any;
    columns: any;
    pagination: number;
    select: string;
    gruping: boolean;
    download: boolean;
    process: boolean;
    editarMonitoramento: boolean;
    showInfo: boolean;
    showDelete: boolean;
    openInfo: string;
    editar: string;
    source: any;
    infoText: any;
    datesValue: any;
    selectedItem: any;
    monitorUrl: string;
    columnProgress: string;
    executeMonitorUrl: string;
    formInvalid: boolean;
    buttonDisabled: any;
    interval: any;
    pageInfo: string;
    monitorVisible: boolean;
    ngOnInit(): void;
    timeReload: {
        textTime: string;
        tempo: number;
    }[];
    reloadValue: any;
    datas: any;
    downloadPdf(data: any): void;
    openErrorDialog(data: any): void;
    openDialog(data: any): void;
    limpar(): void;
    reloadMonitor(event: any): void;
    formatDate(date: any): string;
    selectionData($event: any): void;
    executeMonitor(dates: any): void;
    valueDivider(value: number): number;
    ngDoCheck(): void;
    ngOnDestroy(): void;
    clickEdit($event: any): void;
    clickDelete($event: any): void;
    voltarMonitoramento(): void;
}
export declare class DialogReportInfoDialog {
    dialogRef: MatDialogRef<DialogReportInfoDialog>;
    data: any;
    constructor(dialogRef: MatDialogRef<DialogReportInfoDialog>, data: any);
    onNoClick(): void;
}
export declare class DialogError {
    dialog: MatDialogRef<DialogError>;
    data: any;
    box: ElementRef;
    constructor(dialog: MatDialogRef<DialogError>, data: any);
    onNoClick(): void;
    ngAfterViewInit(): void;
    onResize(event: any): void;
}
