import { OnInit } from '@angular/core';
import { ParametersComponent } from '../parameters/parameters.component';
import { ReqHttpService } from '../../services/req-http.service';
import { SharedService } from '../../models/sharedService';
export declare class ReportComponent implements OnInit {
    private _req;
    private _sharedService;
    constructor(_req: ReqHttpService, _sharedService: SharedService);
    name: string;
    description: string;
    assync: boolean;
    pdfBase64: string;
    private _dataSource;
    dataSource: any;
    parameters: any;
    reportParameters: ParametersComponent;
    parametersComp: ParametersComponent;
    showExecuteResult: boolean;
    showScheduleResult: boolean;
    buttonDisable: boolean;
    process: any;
    codAgendamentoToEdit: any;
    objAgendamentoEdit: any;
    codigoApp: string;
    versaoApp: string;
    reportVisible: boolean;
    ngOnInit(): void;
    executeReport(): void;
    returnParameters(data: any): void;
    openSchedule(fromEditar: boolean): void;
    clearForm(): void;
    ngOnDestroy(): void;
    getAgendamentoReport(agendamento: any, codReport: any): void;
    getAgendamento(): void;
}
