import { EventEmitter, OnInit, SimpleChanges } from '@angular/core';
import { SharedService } from "../../models/sharedService";
import { SchedulingComponent } from "./scheduling.component";
import { ParametersComponent } from "../parameters/parameters.component";
import { ReqHttpService } from "../../services/req-http.service";
export declare class ScheduleProcessComponent implements OnInit {
    private _http;
    private _sharedService;
    sbmParameters: any[];
    processos: any;
    selectParameter: boolean;
    _processSelected: any;
    buttonDisable: boolean;
    process: any;
    static onFormSubmit: EventEmitter<{}>;
    showExecuteResult: boolean;
    showScheduleResult: boolean;
    comboDisabled: boolean;
    assync: boolean;
    buscandoProcessos: boolean;
    codAgendamentoToEdit: any;
    objAgendamentoEdit: any;
    processSelected: any;
    codigoApp: string;
    versaoApp: string;
    processVisible: boolean;
    scheduling: SchedulingComponent;
    parametersComp: ParametersComponent;
    constructor(_http: ReqHttpService, _sharedService: SharedService);
    clearForm(): void;
    returnParameters(data: any): void;
    verificaParametroObrigatorio(): void;
    selectProcess(data: any): void;
    sendProcess(process: any): void;
    ngOnInit(): void;
    buscaProcessos(): void;
    setProcessoChange(processoSelecionar: any): void;
    ngOnChanges(changes: SimpleChanges): void;
    openSchedule(fromEditar: boolean): void;
    executeProcess(): void;
    ngOnDestroy(): void;
    getAgendamentoProcess(agendamento: any, codProcesso: any): void;
    getAgendamento(): void;
}
