"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var req_http_service_1 = require("../../services/req-http.service");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../models/sharedService");
var alert_component_1 = require("../alert/alert.component");
var http_1 = require("@angular/http");
var forms_1 = require("@angular/forms");
var select_service_1 = require("../../services/select.service");
var SelectComponent = /** @class */ (function (_super) {
    __extends(SelectComponent, _super);
    function SelectComponent(_req, _el, _vcRef, _sharedService, _selectService, _http, _translateService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._req = _req;
        _this._el = _el;
        _this._vcRef = _vcRef;
        _this._sharedService = _sharedService;
        _this._selectService = _selectService;
        _this._http = _http;
        _this._translateService = _translateService;
        _this.actionButton = false;
        _this.urlButton = "";
        _this.onclickclear = "";
        _this._queryParam = "";
        // @Output() onActionButtons = new EventEmitter();
        _this._onClickClear = new core_1.EventEmitter();
        _this.stringDataSource = "";
        _this.onActionButtons = new core_1.EventEmitter();
        _this.isNotMasterDetail = true;
        _this._resSucess = new core_1.EventEmitter();
        _this._dataSource = [];
        _this.inputValid = true;
        _this.msgError = "Campo Incorreto";
        _this.reqSucess = false;
        _this.randomNumber = 0;
        _this.reloadReq = false;
        _this.errorServiceComp = false;
        _this.validationsMsg = {
            require: null,
            serviceInvalid: null
        };
        _this.msgLoadingOrNullData = "Aguarde Carregando Dados...";
        _this.setDataSource = function ($data) {
            if (typeof $data == "object") {
                var req_1 = [];
                $data.map(function (a) {
                    var newItem = {
                        label: "",
                        active: false,
                        data: a
                    };
                    for (var count = 0; count < _this.text.length; count++) {
                        if (_this.text.length > 1) {
                            newItem["label"] += a[_this.text[count]] + " " + (_this.text.length == count + 1
                                ? ""
                                : _this.textSeparator) + " ";
                        }
                        else {
                            newItem["label"] = a[_this.text[count]];
                        }
                    }
                    req_1.push(newItem);
                });
                _this._dataSource = req_1;
            }
        };
        _this.setValue = function (value) {
            if ((typeof value == "object" || typeof value == "string") && value) {
                _this._dataSource.map(function (a) {
                    if (_this.valueField != "") {
                        if (a.data[_this.valueField] == value) {
                            _this.itemClicado(a);
                        }
                    }
                    else {
                        if (a.data[_this.text[0]] != undefined &&
                            value[_this.text[0]] != undefined) {
                            if (a.data[_this.text[0]] == value[_this.text[0]]) {
                                _this.itemClicado(a);
                            }
                        }
                    }
                });
            }
        };
        _this.nextCount = -1;
        _this.onChangeValue = new core_1.EventEmitter();
        SbmSelectComponent.push(_this);
        return _this;
    }
    Object.defineProperty(SelectComponent.prototype, "queryParam", {
        get: function () {
            return this._queryParam;
        },
        set: function (val) {
            if (val &&
                val != null &&
                /\?([\w-]+(=[\w-áâãéẽêíîĩóõôúũûç]*)?(&[\w-]+(=[\w-áâãéẽêíîĩóõôúũûç]*)?)*)?$/g.test(val)) {
                this._queryParam = val;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectComponent.prototype, "dataSource", {
        get: function () {
            return this.__dataSource;
        },
        set: function (val) {
            var _this = this;
            this.__dataSource = val;
            if (typeof val == "object") {
                var req_2 = [];
                val.map(function (a) {
                    var newItem = {
                        label: "",
                        active: false,
                        data: a
                    };
                    newItem.label = _this.setLabel(a);
                    req_2.push(newItem);
                });
                this._dataSource = req_2;
                if (this._dataSource.length == 0) {
                    this.msgLoadingOrNullData = "Nenhum elemento encontrado";
                }
            }
            else {
                this.reloadReq = true;
                this.stringDataSource = val;
                this.reqService();
            }
        },
        enumerable: true,
        configurable: true
    });
    SelectComponent.prototype.setLabel = function (data) {
        var label = "";
        for (var count = 0; count < this.text.length; count++) {
            if (this.text.length > 1) {
                if (this.text[count].indexOf(".") > -1) {
                    var rec = this.text[count].split(".");
                    var recTraducao = this.devolveItemEval(data, rec);
                    label += recTraducao + " " + (this.text.length == count + 1 ? "" : this.textSeparator) + " ";
                }
                else {
                    label += data[this.text[count]] + " " + (this.text.length == count + 1 ? "" : this.textSeparator) + " ";
                }
            }
            else {
                if (this.text[count].indexOf(".") > -1) {
                    var rec = this.text[count].split(".");
                    var recTraducao = this.devolveItemEval(data, rec);
                    label = recTraducao;
                }
                else {
                    label = data[this.text[count]];
                }
            }
        }
        return label;
    };
    SelectComponent.prototype.devolveItemEval = function (colA, rec, pos) {
        if (pos === void 0) { pos = 0; }
        var objAtual = rec[pos];
        if (pos < rec.length - 1) {
            if (colA[objAtual]) {
                return this.devolveItemEval(colA[objAtual], rec, ++pos);
            }
            else {
                return "";
            }
        }
        return colA[objAtual];
    };
    SelectComponent.prototype.addItemDataSource = function (itm) {
        var newItem = {
            label: "",
            active: false,
            data: itm
        };
        newItem.label = this.setLabel(itm);
        console.log(newItem);
        this._dataSource.push(itm);
    };
    SelectComponent.prototype.onKeyUp = function (ev) {
        ev.preventDefault();
        ev.stopPropagation();
        var elements = document.querySelectorAll("#" + this.randomDrop + " .collection li");
        var container = document.querySelectorAll("#" + this.randomDrop);
        if (ev.keyCode == 38) {
            if (this.nextCount >= 0) {
                this.nextCount--;
                this.changeElement();
                if (this.nextCount >= 6) {
                    container[0].scrollTop -= 43;
                }
            }
        }
        if (ev.keyCode == 40) {
            if (this.nextCount < elements.length - 1) {
                if (elements.length == this.nextCount + 1) {
                    this.nextCount = -1;
                }
                this.nextCount++;
                this.changeElement();
                if (this.nextCount >= 6) {
                    container[0].scrollTop += 43;
                }
            }
        }
        if (ev.keyCode == 13) {
            elements[this.nextCount].click();
        }
        if (ev.keyCode == 9) {
            // this.closeDrop();
        }
    };
    SelectComponent.prototype.changeElement = function () {
        $("#" + this.randomDrop)
            .find(".collection")
            .children("li")
            .each(function (index, el) {
            $(el).removeClass("active");
        });
        var _el = $("#" + this.randomDrop)
            .find(".collection")
            .children("li")[this.nextCount];
        $(_el).addClass("active");
    };
    SelectComponent.prototype.reqService = function () {
        var _this = this;
        this.msgLoadingOrNullData = "Aguarde Carregando Dados...";
        if (!this.reqSucess) {
            if (this.dataSource != "" && this.dataSource) {
                this._req
                    .xhrGet("/" + _projectCodigo + "/api/" + (this.stringDataSource +
                    this._queryParam))
                    .subscribe(function (ret) {
                    _this.dataSource = _this.reqIndexKey
                        ? ret.res[_this.reqIndexKey]
                        : ret.res;
                    if (_this.dataSource) {
                        _this.reqSucess = true;
                        _this._resSucess.emit(_this.dataSource);
                    }
                    else {
                        _this.msgLoadingOrNullData =
                            "Nenhum elemento encontrado";
                    }
                }, function (err) {
                    _this.msgLoadingOrNullData =
                        "Erro ao Buscar os Dados!";
                    _this.reqSucess = false;
                    _this.errorService = err.res;
                    _this.msgError =
                        "Ocorreu um erro na chamada do serviço";
                    _this.inputValid = false;
                    _this.errorServiceComp = true;
                });
            }
        }
    };
    SelectComponent.prototype.refresh = function () {
        this.reqSucess = false;
        this.dataSource = this.stringDataSource;
        // this.reqService();
    };
    SelectComponent.prototype.fecharSelectsAbertos = function () {
        if ($(".dropdown-content-default.show").length > 0) {
            $(".dropdown-content-default").removeClass("show");
        }
    };
    SelectComponent.prototype.openDrop = function ($el, icon) {
        if (icon === void 0) { icon = false; }
        this.fecharSelectsAbertos();
        if ($el) {
            $el.preventDefault();
            $el.stopPropagation();
        }
        if (icon &&
            document.getElementById(this.randomDrop).classList.contains("show")) {
            this.closeDrop();
            return;
        }
        $(this._el.nativeElement)
            .find("#" + this.randomDrop)
            .css("width", $(this._el.nativeElement)
            .find("mat-form-field")
            .outerWidth() + "px");
        document.getElementById(this.randomDrop).classList.add("show");
        $(this._el.nativeElement)
            .find("#" + this.randomDrop)
            .find("input")
            .focus();
        var container = document.querySelectorAll("#" + this.randomDrop);
        var active = document.querySelectorAll("#" + this.randomDrop + " .collection li.active");
        if ($(active).offset()) {
            container[0].scrollTop =
                $(active).offset().top -
                    $(container)
                        .find(".collection")
                        .offset().top;
        }
    };
    SelectComponent.prototype.closeDrop = function () {
        document.getElementById(this.randomDrop).classList.remove("show");
    };
    SelectComponent.prototype.sendError = function () {
        var _this = this;
        var alert = new alert_component_1.AlertComponent();
        alert
            .show("#" + this.errorService["status"] + " " + this.errorService["statusText"], "Enviar Erro", "Deseja reportar este erro?", "error", true, "não")
            .then(function (ret) {
            if (ret) {
                var error = {
                    servico: _this.errorService["responseURL"],
                    error: _this.errorService["status"],
                    errorText: _this.errorService["statusText"]
                };
            }
        });
    };
    SelectComponent.prototype.actionButtonEmit = function (showForm) {
        /*let a = {
                    'filter': filter,
                    'url': this.urlButton,
                    'id': this.attribute
                };*/
        // this.onActionButtons.emit(a);
        this.onActionButtons.emit({ select: this, showForm: showForm });
        // this._selectService.actionClicked(this);
    };
    SelectComponent.prototype.itemClicado = function (itemAtual, $event) {
        if ($event) {
            $event.preventDefault();
        }
        this.currentItem = itemAtual;
        this.valueDisplay = itemAtual["label"];
        this.searchValue = "";
        $("label[for='" + this.randomId + "']").addClass("active");
        itemAtual["active"] = true;
        this._dataSource.map(function (item) {
            item["active"] =
                JSON.stringify(item["data"]) ==
                    JSON.stringify(itemAtual["data"]);
        });
        if (this.valueField != "") {
            this.value = itemAtual["data"][this.valueField];
        }
        else {
            this.value = itemAtual["data"];
        }
        if (document.getElementById(this.randomId)) {
            document.getElementById(this.randomId).focus();
            document.getElementById(this.randomId).blur();
            this.closeDrop();
        }
    };
    SelectComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this.randomNumber =
            "sbm-select-" + Math.floor(Math.random() * 100000 + 1);
        this.randomDrop =
            "sbm-generated-" + Math.floor(Math.random() * 100000000000 + 1);
        this.css += " sbm-input";
        this.classCss += " " + this.css;
    };
    SelectComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        $(document).ready(function () {
            $(_this._el.nativeElement).attr("style", _this.styleCss);
            window.onkeydown = function (event) {
                if (event.keyCode == 9) {
                    if (!event.target.matches(".select-dropdown") &&
                        !event.target.matches(".dropdown-content-default") &&
                        !event.target.matches(".input-search") &&
                        !event.target.matches(".icon-search") &&
                        !event.target.matches(".sbm-select-icon") &&
                        !event.target.matches(".sbm-select-icon-down")) {
                        var dropdowns = document.getElementsByClassName("dropdown-content-default");
                        var i = void 0;
                        for (i = 0; i < dropdowns.length; i++) {
                            var openDropdown = dropdowns[i];
                            if (openDropdown.classList.contains("show")) {
                                openDropdown.classList.remove("show");
                            }
                        }
                    }
                }
            };
            window.onclick = function (event) {
                if (!event.target.matches(".select-dropdown") &&
                    !event.target.matches(".dropdown-content-default") &&
                    !event.target.matches(".input-search") &&
                    !event.target.matches(".icon-search") &&
                    !event.target.matches(".sbm-select-icon") &&
                    !event.target.matches(".sbm-select-icon-down")) {
                    var dropdowns = document.getElementsByClassName("dropdown-content-default");
                    var i = void 0;
                    for (i = 0; i < dropdowns.length; i++) {
                        var openDropdown = dropdowns[i];
                        if (openDropdown.classList.contains("show")) {
                            openDropdown.classList.remove("show");
                        }
                    }
                }
            };
        });
        this._resSucess.subscribe(function (ret) {
            _this.onChangeValue.emit(_this.itemSelecionado);
        });
        this.onChangeValue.subscribe(function (ret) {
            _this.itemSelecionado = ret;
            _this.marcaItemComoSelecionado(ret);
        });
    };
    SelectComponent.prototype.marcaItemComoSelecionado = function (ret) {
        var _this = this;
        if (ret) {
            var item = void 0;
            if (this.valueField != "") {
                item = this._dataSource.filter(function (item) {
                    return JSON.stringify(item["data"][_this.valueField]) ==
                        JSON.stringify(ret);
                });
            }
            else {
                item = this._dataSource.filter(function (item) { return JSON.stringify(item["data"]) == JSON.stringify(ret); });
            }
            if (item.length > 0) {
                this.valueDisplay = item[0]["label"];
                this.itemClicado(item[0]);
                this._onClick.emit(item[0]["data"]);
                if (this.onClick != "") {
                    window[this.onClick](item[0]["data"]);
                }
            }
        }
        else {
            this.valueDisplay = "";
            if (this._dataSource) {
                if (this._dataSource.length > 0) {
                    this._dataSource.map(function (item) {
                        item.active = false;
                    });
                }
            }
        }
    };
    SelectComponent.prototype.itemClicadoClear = function ($event) {
        this.searchValue = "";
        this.value = undefined;
        this._onClickClear.emit($event);
        if (this.onclickclear != "") {
            window[this.onclickclear]($event);
        }
    };
    SelectComponent._onActionButtons = new core_1.EventEmitter();
    SelectComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: "sbm-select",
                    template: require('./select.component.html'),

                    styles: [require('./select.component.css')],
                    host: {
                        "[class]": "classCss"
                    },
                    providers: [
                        abstract_ngmodel_1.MakeProvider(SelectComponent),
                        {
                            provide: abstract_ngmodel_1.AbstractNgModel,
                            useExisting: core_1.forwardRef(function () { return SelectComponent; })
                        }
                    ]
                },] },
    ];
    /** @nocollapse */
    SelectComponent.ctorParameters = function () { return [
        { type: req_http_service_1.ReqHttpService, },
        { type: core_1.ElementRef, },
        { type: core_1.ViewContainerRef, },
        { type: sharedService_1.SharedService, },
        { type: select_service_1.SelectService, },
        { type: http_1.Http, },
        { type: core_2.TranslateService, },
    ]; };
    SelectComponent.propDecorators = {
        "input": [{ type: core_1.ViewChild, args: ["combobox",] },],
        "component2": [{ type: core_1.ViewChild, args: ["component2",] },],
        "actionButton": [{ type: core_1.Input, args: ["actionbutton",] },],
        "urlButton": [{ type: core_1.Input, args: ["urlbutton",] },],
        "onclickclear": [{ type: core_1.Input, args: ["onclickclear",] },],
        "queryParam": [{ type: core_1.Input, args: ["queryparam",] },],
        "_onClickClear": [{ type: core_1.Output },],
        "dataSource": [{ type: core_1.Input, args: ["datasource",] },],
        "onKeyUp": [{ type: core_1.HostListener, args: ["keyup", ["$event"],] },],
    };
    return SelectComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.SelectComponent = SelectComponent;
