import { OnInit, ChangeDetectorRef, ElementRef } from '@angular/core';
import { MediaMatcher } from '@angular/cdk/layout';
import { MatSidenav } from '@angular/material';
export declare class SidenavComponent implements OnInit {
    mobileQuery: MediaQueryList;
    private _mobileQueryListener;
    constructor(changeDetectorRef: ChangeDetectorRef, media: MediaMatcher);
    sidenav: MatSidenav;
    sidenavContent: any;
    sideContainer: ElementRef;
    disableClose: boolean;
    width: string;
    height: string;
    tooltip: string;
    minHeight: string;
    btnOpen: boolean;
    mode: "over" | "push" | "side";
    iconBtnClose: string;
    private _opened;
    opened: any;
    toggle(): void;
    open(): void;
    close(): void;
    swipeLeft(ev: any): void;
    swipeRight(ev: any): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
}
