"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var core_2 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var core_3 = require("@ngx-translate/core");
var http_1 = require("@angular/http");
var sharedService_1 = require("../../models/sharedService");
var TabsErrorComponent = /** @class */ (function (_super) {
    __extends(TabsErrorComponent, _super);
    function TabsErrorComponent(_http, _sharedService, _translateService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._http = _http;
        _this._sharedService = _sharedService;
        _this._translateService = _translateService;
        _this.errors = [];
        _this.visible = true;
        _this.toggleVisibilidade = new core_1.EventEmitter();
        return _this;
    }
    TabsErrorComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
    };
    TabsErrorComponent.prototype.toggleVisibilidadeMensagem = function () {
        this.visible = !this.visible;
        this.toggleVisibilidade.emit(this.visible);
    };
    TabsErrorComponent.decorators = [
        { type: core_2.Component, args: [{
                    selector: 'sbm-tabs-error',
                    template: require('./tabs-error.component.html'),

                    styles: [require('./tabs-error.component.css')],
               },] },
    ];
    /** @nocollapse */
    TabsErrorComponent.ctorParameters = function () { return [
        { type: http_1.Http, },
        { type: sharedService_1.SharedService, },
        { type: core_3.TranslateService, },
    ]; };
    TabsErrorComponent.propDecorators = {
        "errors": [{ type: core_2.Input },],
        "visible": [{ type: core_2.Input },],
        "toggleVisibilidade": [{ type: core_2.Input },],
    };
    return TabsErrorComponent;
}(abstract_ngmodel_1.AbstractNgModel));
exports.TabsErrorComponent = TabsErrorComponent;
