export declare abstract class AbstractTabs {
    tabTemplate: string;
    id: any;
    static tabChange: any;
    defaultTapProperties: {
        title: string;
        favicon: string;
        url: string;
    };
    options: any;
    elTab: any;
    animationStyleEl: any;
    draggabillyInstances: any;
    styleHtmlTab: any;
    instanceId: number;
    tabGeneric: any;
    onTabAdd: any;
    onActiveTabChange: any;
    onTabRemove: any;
    init(el: any, options: any): void;
    setupStyleEl(): void;
    setupEvents(): void;
    readonly tabEls: any;
    readonly tabContentEl: any;
    readonly tabWidth: number;
    readonly tabEffectiveWidth: number;
    readonly tabPositions: any[];
    layoutTabs(): void;
    fixZIndexes(): void;
    createNewTabEl(): Element;
    addTabComp(tabProperties?: any): Element;
    setCurrentTab(tabEl: any): void;
    removeTab(tabEl: any): void;
    updateTab(tabEl: any, tabProperties: any): void;
    cleanUpPreviouslyDraggedTabs(): void;
    setupDraggabilly(): void;
    animateTabMove(tabEl: any, originIndex: any, destinationIndex: any): void;
}
