import { AfterViewInit, Compiler, Component, ComponentFactoryResolver, ComponentRef, ElementRef, EventEmitter, QueryList, Type, ViewContainerRef } from '@angular/core';
import { TabComponent } from '../tab.component';
import { SharedService } from '../../../models/sharedService';
import { AbstractTabs } from '../abstract-tabs/abstract.tabs';
export declare class TabsChromeComponent extends AbstractTabs implements AfterViewInit {
    private _viewContainerRef;
    private componentFactoryResolver;
    private compiler;
    private _sharedService;
    constructor(_viewContainerRef: ViewContainerRef, componentFactoryResolver: ComponentFactoryResolver, compiler: Compiler, _sharedService: SharedService);
    container: ViewContainerRef;
    type: Type<Component>;
    cmpRef: ComponentRef<Component>;
    el: HTMLElement;
    tabsContent: ElementRef;
    ul: any;
    chromeTabs: ElementRef;
    dinamicContainer: ElementRef;
    css: string;
    layout: string;
    padding: string;
    closeButton: boolean;
    isPath: boolean;
    onTabClick: EventEmitter<{}>;
    onAfterViewInit: EventEmitter<{}>;
    onSelectedTab: EventEmitter<{}>;
    onRemoveTab: EventEmitter<{}>;
    tabs: QueryList<TabComponent>;
    selectedIndex: any;
    tabsDinamic: any[];
    indexActive: number;
    chromeTabsClass: any;
    tabsSaved: any[];
    savedTab: any;
    _tabs: any;
    modulesDinamic: any[];
    compDinamic: any[];
    _columns: any;
    columns: any;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    observeList(): void;
    static tabSaved: any;
    removeDinamic(event: any, tab: any): void;
    selectedTab(tab: any): void;
    removedTab(tab: any): void;
    addTab(label: string, content: any, isPath: boolean, id?: any, disabled?: any, isActive?: any, icon?: any): void;
    selectTab(tab: any): void;
    createComponenteDynamic(html: any, data: any): void;
}
