import { OnInit, QueryList } from '@angular/core';
import { AbstractNgModel } from '../../models/abstract.ngmodel';
import { SharedService } from '../../models/sharedService';
import { TranslateService } from '@ngx-translate/core';
import { Http } from '@angular/http';
import { SbmHttpClientService } from '../../services/sbm-http-client.service';
import { TimelineContainerComponent } from './timeline-container/timeline-container.component';
export declare class TimelineComponent extends AbstractNgModel implements OnInit {
    private _req;
    constructor(_shared: SharedService, _tranlate: TranslateService, _http: Http, _req: SbmHttpClientService);
    timelineContainer: QueryList<TimelineContainerComponent>;
    data: any;
    private _dataSource;
    dataSource: any;
    displayTitle: string;
    displayDesc: string;
    displayImg: string;
    displayEvent: string;
    height: string;
    centered: boolean;
    reqService(url: any): void;
    clickItem(event: any): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
}
