import { OnInit, ElementRef, OnDestroy } from '@angular/core';
import { SbmHttpClientService } from '../../services/sbm-http-client.service';
import { TranslateService } from '@ngx-translate/core';
import { Http } from '@angular/http';
import { AbstractNgModel } from '../../models/abstract.ngmodel';
import { SharedService } from '../../models/sharedService';
export declare class TreeviewComponent extends AbstractNgModel implements OnInit, OnDestroy {
    private _service;
    private _translateService;
    _http: Http;
    private _sharedService;
    private elementRef;
    constructor(_service: SbmHttpClientService, _translateService: TranslateService, _http: Http, _sharedService: SharedService, elementRef: ElementRef);
    items: any;
    showCheckboxMode: string;
    children: string;
    selectedKey: string;
    selectNodesRecursivelly: boolean;
    disabledKey: string;
    expandedKey: string;
    onSelectNode: string;
    onSelectChange: string;
    onItemRendered: string;
    searchValue: string;
    search: boolean;
    height: any;
    _onSelectNode: any;
    _onSelectChange: any;
    _onItemRendered: any;
    dxTreeView: any;
    _selection: string;
    selection: string;
    private _dataSource;
    dataSource: any;
    setDataSource: any;
    getDxTreeviewInstance(v: any): any;
    reqService(url: any): void;
    recursiveDataSource(data: any): any;
    createTreeview(data: any): any;
    selectionChange(event: any): void;
    itemClicado(event: any): void;
    itemRenderizado($event: any): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
}
