"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var mask_telefone_pipe_1 = require("../pipes/mask-telefone.pipe");
var mask_directive_1 = require("../diretives/mask.directive");
var scheduling_component_1 = require("../components/scheduling/scheduling.component");
var schedule_times_component_1 = require("../components/scheduling/schedule-times.component");
var schedule_process_component_1 = require("../components/scheduling/schedule-process.component");
var progress_component_1 = require("../components/progress/progress.component");
var pdf_component_1 = require("../components/pdf/pdf.component");
var multiselect_dropdown_component_1 = require("../components/multiselect-dropdown/multiselect-dropdown.component");
var calc_button_component_1 = require("../components/calc/calc-button.component");
var common_1 = require("@angular/common");
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var http_1 = require("@angular/http");
var input_text_component_1 = require("../components/input/input-text/input-text.component");
var input_cep_component_1 = require("../components/input/input-cep/input-cep.component");
var input_cnpj_component_1 = require("../components/input/input-cnpj/input-cnpj.component");
var input_cpf_component_1 = require("../components/input/input-cpf/input-cpf.component");
var input_email_component_1 = require("../components/input/input-email/input-email.component");
var input_mask_component_1 = require("../components/input/input-mask/input-mask.component");
var input_number_component_1 = require("../components/input/input-number/input-number.component");
var input_password_component_1 = require("../components/input/input-password/input-password.component");
var input_telefone_component_1 = require("../components/input/input-telefone/input-telefone.component");
var accordion_component_1 = require("../components/accordion/accordion.component");
var accordion_group_component_1 = require("../components/accordion/accordion-group.component");
var alert_component_1 = require("../components/alert/alert.component");
var autocomplete_component_1 = require("../components/autocomplete/autocomplete.component");
var breadcrumb_component_1 = require("../components/breadcrumb/breadcrumb.component");
var button_component_1 = require("../components/button/button.component");
var button_submit_component_1 = require("../components/button-submit/button-submit.component");
var checkbox_component_1 = require("../components/checkbox/checkbox.component");
var crud_component_1 = require("../components/crud/crud.component");
var datebox_component_1 = require("../components/datebox/datebox.component");
var fieldset_component_1 = require("../components/fieldset/fieldset.component");
var filters_component_1 = require("../components/filters/filters.component");
var form_component_1 = require("../components/form/form.component");
var grid_component_1 = require("../components/grid/grid.component");
var list_view_component_1 = require("../components/list-view/list-view.component");
var menu_component_1 = require("../components/menu/menu.component");
var modal_component_1 = require("../components/modal/modal.component");
var monitor_component_1 = require("../components/monitor/monitor.component");
var multiselect_component_1 = require("../components/multiselect/multiselect.component");
var notification_component_1 = require("../components/notification/notification.component");
var parameters_component_1 = require("../components/parameters/parameters.component");
var progressbar_component_1 = require("../components/progressbar/progressbar.component");
var radio_component_1 = require("../components/radio/radio.component");
var relatorios_component_1 = require("../components/relatorios/relatorios.component");
var rotator_component_1 = require("../components/rotator/rotator.component");
var select_component_1 = require("../components/select/select.component");
var tab_component_1 = require("../components/tabs/tab.component");
var tabs_component_1 = require("../components/tabs/tabs.component");
var treeview_component_1 = require("../components/treeview/treeview.component");
var textarea_component_1 = require("../components/input/textarea/textarea.component");
var breadcrumb_crud_component_1 = require("../components/breadcrumb-crud/breadcrumb-crud.component");
var money_component_1 = require("../components/input/money/money.component");
var upload_component_1 = require("../components/upload/upload.component");
var image_component_1 = require("../components/image/image.component");
var label_component_1 = require("../components/label/label.component");
var filter_pipe_1 = require("../pipes/filter.pipe");
var core_2 = require("@ngx-translate/core");
var drag_drop_content_1 = require("../components/drag-and-drop/drag-drop-content");
var drop_component_1 = require("../components/drag-and-drop/drop.component");
var drag_component_1 = require("../components/drag-and-drop/drag.component");
var drag_and_drop_component_1 = require("../components/drag-and-drop/drag-and-drop.component");
var master_detail_form_component_1 = require("../components/master-detail-form/master-detail-form.component");
var master_detail_component_1 = require("../components/master-detail/master-detail.component");
var pie_component_1 = require("../components/graps/pie/pie.component");
var bar_component_1 = require("../components/graps/bar/bar.component");
var line_component_1 = require("../components/graps/line/line.component");
var calc_component_1 = require("../components/calc/calc.component");
var ng2_pdf_viewer_1 = require("ng2-pdf-viewer");
var row_component_1 = require("../components/row/row.component");
var color_picker_component_1 = require("../components/color-picker/color-picker.component");
var bookmark_component_1 = require("../components/bookmark/bookmark.component");
var upload_image_component_1 = require("../components/upload-image/upload-image.component");
var input_ip_component_1 = require("../components/input/input-ip/input-ip.component");
var datetime_component_1 = require("../components/datetime/datetime.component");
var datetime_native_component_1 = require("../components/datetime-native/datetime-native.component");
var numberfixedlen_pipe_1 = require("../components/datetime-native/numberfixedlen.pipe");
var entity_component_1 = require("../components/entity/entity.component");
var audit_component_1 = require("../components/audit/audit.component");
var translate_pipe_pipe_1 = require("../pipes/translate-pipe.pipe");
var safePipe_1 = require("../pipes/safePipe");
var phone_directive_1 = require("../diretives/phone.directive");
var cnpj_directive_1 = require("../diretives/cnpj.directive");
var cpf_directive_1 = require("../diretives/cpf.directive");
var cep_directive_1 = require("../diretives/cep.directive");
var report_component_1 = require("../components/report/report.component");
var series_component_1 = require("../components/graps/series/series.component");
var tooltip_directive_1 = require("../diretives/tooltip.directive");
var req_http_service_1 = require("../services/req-http.service");
var ng2_currency_mask_1 = require("ng2-currency-mask");
var ng2_drag_drop_1 = require("ng2-drag-drop");
var router_1 = require("@angular/router");
var devextreme_angular_1 = require("devextreme-angular");
var ngx_color_picker_1 = require("ngx-color-picker");
var ng_pick_datetime_1 = require("ng-pick-datetime");
var ng2_slim_loading_bar_1 = require("ng2-slim-loading-bar");
var ng2_toasty_1 = require("ng2-toasty");
var material_1 = require("@angular/material");
var moment_1 = require("@mat-datetimepicker/moment");
var core_3 = require("@mat-datetimepicker/core");
require("webui-popover/src/jquery.webui-popover.js");
var web_sql_service_1 = require("../services/web-sql.service");
var list_option_component_1 = require("../components/list-view/list-option.component");
var radio_option_component_1 = require("../components/radio/radio-option.component");
var tab_generic_component_1 = require("../components/tabs/tab-generic/tab-generic.component");
var indexed_db_service_1 = require("../services/indexed-db.service");
var tabs_chrome_componente_1 = require("../components/tabs/tabs-chrome.component/tabs-chrome.componente");
var http_2 = require("@angular/common/http");
var InterceptorHttp_1 = require("../services/InterceptorHttp");
var sbm_http_client_service_1 = require("../services/sbm-http-client.service");
var breadcrumb_service_1 = require("../services/breadcrumb.service");
var select_service_1 = require("../services/select.service");
var div_component_1 = require("../components/div/div.component");
var editor_component_1 = require("../components/editor/editor.component");
var regexp_directive_1 = require("../diretives/regexp.directive");
var dialog_filter_component_1 = require("../components/filters/dialog-filter/dialog-filter.component");
var max_directive_1 = require("../diretives/max.directive");
var min_directive_1 = require("../diretives/min.directive");
var dialog_audit_component_1 = require("../components/crud/dialog-audit/dialog-audit.component");
var crud_container_component_1 = require("../components/crud/crud-container.component");
var generic_key_component_1 = require("../components/generic-key/generic-key.component");
var master_detail_form_generic_1 = require("../components/master-detail-form/master-detail-form-generic");
var tabs_error_component_1 = require("../components/tabs-error/tabs-error.component");
var tabs_error_service_1 = require("../components/tabs-error/tabs-error.service");
var sidenav_component_1 = require("../components/sidenav/sidenav.component");
var layout_1 = require("@angular/cdk/layout");
var timeline_module_1 = require("../components/timeline/timeline.module");
var sharedService_1 = require("../models/sharedService");
var sharedService_2 = require("../models/sharedService");
exports.SharedService = sharedService_2.SharedService;
var image_component_2 = require("../components/image/image.component");
exports.ImageComponent = image_component_2.ImageComponent;
var label_component_2 = require("../components/label/label.component");
exports.LabelComponent = label_component_2.LabelComponent;
var filter_pipe_2 = require("../pipes/filter.pipe");
exports.FilterAllPipe = filter_pipe_2.FilterAllPipe;
exports.FilterPipe = filter_pipe_2.FilterPipe;
exports.MultiSelectFilterPipe = filter_pipe_2.MultiSelectFilterPipe;
exports.SelectFilterPipe = filter_pipe_2.SelectFilterPipe;
var abstract_component_1 = require("../models/abstract.component");
exports.AbstractComponent = abstract_component_1.AbstractComponent;
var tabs_chrome_componente_2 = require("../components/tabs/tabs-chrome.component/tabs-chrome.componente");
exports.TabsChromeComponent = tabs_chrome_componente_2.TabsChromeComponent;
var generic_key_component_2 = require("../components/generic-key/generic-key.component");
exports.GenericKeyComponent = generic_key_component_2.GenericKeyComponent;
var master_detail_form_component_2 = require("../components/master-detail-form/master-detail-form.component");
exports.SbmMasterDetailForm = master_detail_form_component_2.SbmMasterDetailForm;
var div_component_2 = require("../components/div/div.component");
exports.DivComponent = div_component_2.DivComponent;
var audit_component_2 = require("../components/audit/audit.component");
exports.AuditComponent = audit_component_2.AuditComponent;
var tab_generic_component_2 = require("../components/tabs/tab-generic/tab-generic.component");
exports.TabGenericComponent = tab_generic_component_2.TabGenericComponent;
var editor_component_2 = require("../components/editor/editor.component");
exports.EditorComponent = editor_component_2.EditorComponent;
var input_text_component_2 = require("../components/input/input-text/input-text.component");
exports.InputTextComponent = input_text_component_2.InputTextComponent;
var input_cep_component_2 = require("../components/input/input-cep/input-cep.component");
exports.InputCepComponent = input_cep_component_2.InputCepComponent;
var input_cnpj_component_2 = require("../components/input/input-cnpj/input-cnpj.component");
exports.InputCnpjComponent = input_cnpj_component_2.InputCnpjComponent;
var input_cpf_component_2 = require("../components/input/input-cpf/input-cpf.component");
exports.InputCpfComponent = input_cpf_component_2.InputCpfComponent;
var input_email_component_2 = require("../components/input/input-email/input-email.component");
exports.InputEmailComponent = input_email_component_2.InputEmailComponent;
var input_mask_component_2 = require("../components/input/input-mask/input-mask.component");
exports.InputMaskComponent = input_mask_component_2.InputMaskComponent;
var input_number_component_2 = require("../components/input/input-number/input-number.component");
exports.InputNumberComponent = input_number_component_2.InputNumberComponent;
var input_password_component_2 = require("../components/input/input-password/input-password.component");
exports.InputPasswordComponent = input_password_component_2.InputPasswordComponent;
var input_telefone_component_2 = require("../components/input/input-telefone/input-telefone.component");
exports.InputTelefoneComponent = input_telefone_component_2.InputTelefoneComponent;
var accordion_component_2 = require("../components/accordion/accordion.component");
exports.AccordionComponent = accordion_component_2.AccordionComponent;
var accordion_group_component_2 = require("../components/accordion/accordion-group.component");
exports.AccordionGroupComponent = accordion_group_component_2.AccordionGroupComponent;
var alert_component_2 = require("../components/alert/alert.component");
exports.AlertComponent = alert_component_2.AlertComponent;
var autocomplete_component_2 = require("../components/autocomplete/autocomplete.component");
exports.AutocompleteComponent = autocomplete_component_2.AutocompleteComponent;
var breadcrumb_component_2 = require("../components/breadcrumb/breadcrumb.component");
exports.BreadcrumbComponent = breadcrumb_component_2.BreadcrumbComponent;
var button_component_2 = require("../components/button/button.component");
exports.ButtonComponent = button_component_2.ButtonComponent;
var button_submit_component_2 = require("../components/button-submit/button-submit.component");
exports.ButtonSubmitComponent = button_submit_component_2.ButtonSubmitComponent;
var checkbox_component_2 = require("../components/checkbox/checkbox.component");
exports.CheckboxComponent = checkbox_component_2.CheckboxComponent;
var crud_component_2 = require("../components/crud/crud.component");
exports.CrudComponent = crud_component_2.CrudComponent;
exports.CrudFormComponent = crud_component_2.CrudFormComponent;
var datebox_component_2 = require("../components/datebox/datebox.component");
exports.DateboxComponent = datebox_component_2.DateboxComponent;
var fieldset_component_2 = require("../components/fieldset/fieldset.component");
exports.FieldsetComponent = fieldset_component_2.FieldsetComponent;
var filters_component_2 = require("../components/filters/filters.component");
exports.FiltersComponent = filters_component_2.FiltersComponent;
var form_component_2 = require("../components/form/form.component");
exports.FormComponent = form_component_2.FormComponent;
var grid_component_2 = require("../components/grid/grid.component");
exports.GridComponent = grid_component_2.GridComponent;
var list_view_component_2 = require("../components/list-view/list-view.component");
exports.ListViewComponent = list_view_component_2.ListViewComponent;
var menu_component_2 = require("../components/menu/menu.component");
exports.MenuComponent = menu_component_2.MenuComponent;
exports.ItemMenuComponent = menu_component_2.ItemMenuComponent;
var modal_component_2 = require("../components/modal/modal.component");
exports.ModalComponent = modal_component_2.ModalComponent;
var master_detail_component_2 = require("../components/master-detail/master-detail.component");
exports.MasterDetailComponent = master_detail_component_2.MasterDetailComponent;
exports.DialogMasterDetail = master_detail_component_2.DialogMasterDetail;
var monitor_component_2 = require("../components/monitor/monitor.component");
exports.DialogError = monitor_component_2.DialogError;
exports.DialogReportInfoDialog = monitor_component_2.DialogReportInfoDialog;
exports.MonitorComponent = monitor_component_2.MonitorComponent;
var multiselect_component_2 = require("../components/multiselect/multiselect.component");
exports.MultiselectComponent = multiselect_component_2.MultiselectComponent;
var notification_component_2 = require("../components/notification/notification.component");
exports.NotificationComponent = notification_component_2.NotificationComponent;
var parameters_component_2 = require("../components/parameters/parameters.component");
exports.ParametersComponent = parameters_component_2.ParametersComponent;
var progressbar_component_2 = require("../components/progressbar/progressbar.component");
exports.ProgressbarComponent = progressbar_component_2.ProgressbarComponent;
var radio_component_2 = require("../components/radio/radio.component");
exports.RadioComponent = radio_component_2.RadioComponent;
var relatorios_component_2 = require("../components/relatorios/relatorios.component");
exports.RelatoriosComponent = relatorios_component_2.RelatoriosComponent;
var rotator_component_2 = require("../components/rotator/rotator.component");
exports.RotatorComponent = rotator_component_2.RotatorComponent;
var select_component_2 = require("../components/select/select.component");
exports.SelectComponent = select_component_2.SelectComponent;
var tab_component_2 = require("../components/tabs/tab.component");
exports.TabComponent = tab_component_2.TabComponent;
var tabs_component_2 = require("../components/tabs/tabs.component");
exports.TabsComponent = tabs_component_2.TabsComponent;
var treeview_component_2 = require("../components/treeview/treeview.component");
exports.TreeviewComponent = treeview_component_2.TreeviewComponent;
var textarea_component_2 = require("../components/input/textarea/textarea.component");
exports.TextareaComponent = textarea_component_2.TextareaComponent;
var breadcrumb_crud_component_2 = require("../components/breadcrumb-crud/breadcrumb-crud.component");
exports.BreadcrumbCrudComponent = breadcrumb_crud_component_2.BreadcrumbCrudComponent;
var money_component_2 = require("../components/input/money/money.component");
exports.MoneyComponent = money_component_2.MoneyComponent;
var pie_component_2 = require("../components/graps/pie/pie.component");
exports.PieComponent = pie_component_2.PieComponent;
var bar_component_2 = require("../components/graps/bar/bar.component");
exports.BarComponent = bar_component_2.BarComponent;
var line_component_2 = require("../components/graps/line/line.component");
exports.LineComponent = line_component_2.LineComponent;
var multiselect_dropdown_component_2 = require("../components/multiselect-dropdown/multiselect-dropdown.component");
exports.MultiselectDropdownComponent = multiselect_dropdown_component_2.MultiselectDropdownComponent;
var calc_button_component_2 = require("../components/calc/calc-button.component");
exports.CalcButtonComponent = calc_button_component_2.CalcButtonComponent;
var mask_telefone_pipe_2 = require("../pipes/mask-telefone.pipe");
exports.MaskTelefonePipe = mask_telefone_pipe_2.MaskTelefonePipe;
var mask_directive_2 = require("../diretives/mask.directive");
exports.MaskDirective = mask_directive_2.MaskDirective;
var max_directive_2 = require("../diretives/max.directive");
exports.MaxDirective = max_directive_2.MaxDirective;
var min_directive_2 = require("../diretives/min.directive");
exports.MinDirective = min_directive_2.MinDirective;
var scheduling_component_2 = require("../components/scheduling/scheduling.component");
exports.SchedulingComponent = scheduling_component_2.SchedulingComponent;
var schedule_times_component_2 = require("../components/scheduling/schedule-times.component");
exports.ScheduleTimesComponent = schedule_times_component_2.ScheduleTimesComponent;
var schedule_process_component_2 = require("../components/scheduling/schedule-process.component");
exports.ScheduleProcessComponent = schedule_process_component_2.ScheduleProcessComponent;
var progress_component_2 = require("../components/progress/progress.component");
exports.ProgressComponent = progress_component_2.ProgressComponent;
var pdf_component_2 = require("../components/pdf/pdf.component");
exports.PdfComponent = pdf_component_2.PdfComponent;
exports.PDFDialogComponent = pdf_component_2.PDFDialogComponent;
var input_ip_component_2 = require("../components/input/input-ip/input-ip.component");
exports.InputIpComponent = input_ip_component_2.InputIpComponent;
var datetime_component_2 = require("../components/datetime/datetime.component");
exports.DatetimeComponent = datetime_component_2.DatetimeComponent;
var datetime_native_component_2 = require("../components/datetime-native/datetime-native.component");
exports.DatetimeNativeComponent = datetime_native_component_2.DatetimeNativeComponent;
var entity_component_2 = require("../components/entity/entity.component");
exports.EntityComponent = entity_component_2.EntityComponent;
var ng2_pdf_viewer_2 = require("ng2-pdf-viewer");
exports.PdfViewerComponent = ng2_pdf_viewer_2.PdfViewerComponent;
var translate_pipe_pipe_2 = require("../pipes/translate-pipe.pipe");
exports.TranslatePipe = translate_pipe_pipe_2.TranslatePipe;
var safePipe_2 = require("../pipes/safePipe");
exports.SafePipe = safePipe_2.SafePipe;
var phone_directive_2 = require("../diretives/phone.directive");
exports.PhoneDirective = phone_directive_2.PhoneDirective;
var cnpj_directive_2 = require("../diretives/cnpj.directive");
exports.CnpjDirective = cnpj_directive_2.CnpjDirective;
var cpf_directive_2 = require("../diretives/cpf.directive");
exports.CpfDirective = cpf_directive_2.CpfDirective;
var cep_directive_2 = require("../diretives/cep.directive");
exports.CepDirective = cep_directive_2.CepDirective;
var tooltip_directive_2 = require("../diretives/tooltip.directive");
exports.TooltipDirective = tooltip_directive_2.TooltipDirective;
var regexp_directive_2 = require("../diretives/regexp.directive");
exports.RegExpDirective = regexp_directive_2.RegExpDirective;
var dialog_audit_component_2 = require("../components/crud/dialog-audit/dialog-audit.component");
exports.DialogAuditDetail = dialog_audit_component_2.DialogAuditDetail;
var dialog_filter_component_2 = require("../components/filters/dialog-filter/dialog-filter.component");
exports.DialogFilterDetail = dialog_filter_component_2.DialogFilterDetail;
var req_http_service_2 = require("../services/req-http.service");
exports.ReqHttpService = req_http_service_2.ReqHttpService;
var tabs_error_service_2 = require("../components/tabs-error/tabs-error.service");
exports.TabsErrorService = tabs_error_service_2.TabsErrorService;
var sidenav_component_2 = require("../components/sidenav/sidenav.component");
exports.SidenavComponent = sidenav_component_2.SidenavComponent;
var platform_browser_1 = require("@angular/platform-browser");
var MyHammerConfig = /** @class */ (function (_super) {
    __extends(MyHammerConfig, _super);
    function MyHammerConfig() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.overrides = {
            'swipe': { direction: Hammer.DIRECTION_ALL }
        };
        return _this;
    }
    return MyHammerConfig;
}(platform_browser_1.HammerGestureConfig));
exports.MyHammerConfig = MyHammerConfig;
var ɵ0 = { float: 'auto' };
exports.ɵ0 = ɵ0;
var SbmModule = /** @class */ (function () {
    function SbmModule() {
    }
    SbmModule.forRoot = function () {
        return { ngModule: SbmModule, providers: [] };
    };
    SbmModule.decorators = [
        { type: core_1.NgModule, args: [{
                    imports: [
                        common_1.CommonModule,
                        forms_1.FormsModule,
                        http_2.HttpClientModule,
                        http_1.HttpModule,
                        ng2_currency_mask_1.CurrencyMaskModule,
                        devextreme_angular_1.DevExtremeModule,
                        ngx_color_picker_1.ColorPickerModule,
                        ng_pick_datetime_1.DateTimePickerModule,
                        forms_1.ReactiveFormsModule,
                        http_1.JsonpModule,
                        core_2.TranslateModule.forRoot(),
                        ng2_drag_drop_1.Ng2DragDropModule.forRoot(),
                        router_1.RouterModule,
                        ng2_slim_loading_bar_1.SlimLoadingBarModule.forRoot(),
                        ng2_toasty_1.ToastyModule.forRoot(),
                        timeline_module_1.TimelineModule,
                        material_1.MatFormFieldModule,
                        material_1.MatInputModule,
                        material_1.MatIconModule,
                        material_1.MatButtonModule,
                        material_1.MatAutocompleteModule,
                        material_1.MatRadioModule,
                        material_1.MatCheckboxModule,
                        material_1.MatExpansionModule,
                        material_1.MatTabsModule,
                        material_1.MatListModule,
                        material_1.MatButtonModule,
                        material_1.MatDialogModule,
                        material_1.MatSidenavModule,
                        material_1.MatMenuModule,
                        material_1.MatChipsModule,
                        material_1.MatDatepickerModule,
                        material_1.MatNativeDateModule,
                        material_1.MatGridListModule,
                        moment_1.MatMomentDatetimeModule,
                        core_3.MatDatetimepickerModule
                    ],
                    declarations: [
                        input_text_component_1.InputTextComponent,
                        textarea_component_1.TextareaComponent,
                        input_cep_component_1.InputCepComponent,
                        input_cnpj_component_1.InputCnpjComponent,
                        input_cpf_component_1.InputCpfComponent,
                        input_email_component_1.InputEmailComponent,
                        input_mask_component_1.InputMaskComponent,
                        input_number_component_1.InputNumberComponent,
                        input_password_component_1.InputPasswordComponent,
                        input_telefone_component_1.InputTelefoneComponent,
                        editor_component_1.EditorComponent,
                        accordion_component_1.AccordionComponent,
                        accordion_group_component_1.AccordionGroupComponent,
                        alert_component_1.AlertComponent,
                        autocomplete_component_1.AutocompleteComponent,
                        breadcrumb_component_1.BreadcrumbComponent,
                        breadcrumb_crud_component_1.BreadcrumbCrudComponent,
                        button_component_1.ButtonComponent,
                        button_submit_component_1.ButtonSubmitComponent,
                        checkbox_component_1.CheckboxComponent,
                        bookmark_component_1.BookmarkComponent,
                        calc_button_component_1.CalcButtonComponent,
                        multiselect_dropdown_component_1.MultiselectDropdownComponent,
                        crud_component_1.CrudComponent,
                        grid_component_1.SbmGridColumn,
                        master_detail_form_component_1.SbmMasterDetailForm,
                        master_detail_component_1.MasterDetailComponent,
                        crud_component_1.CrudFormComponent,
                        filters_component_1.FiltersComponent,
                        menu_component_1.SubMenuComponent,
                        monitor_component_1.MonitorComponent,
                        ng2_pdf_viewer_1.PdfViewerComponent,
                        datebox_component_1.DateboxComponent,
                        fieldset_component_1.FieldsetComponent,
                        form_component_1.FormComponent,
                        grid_component_1.GridComponent,
                        list_view_component_1.ListViewComponent,
                        list_option_component_1.ListOptions,
                        menu_component_1.MenuComponent,
                        menu_component_1.ItemMenuComponent,
                        modal_component_1.ModalComponent,
                        multiselect_component_1.MultiselectComponent,
                        notification_component_1.NotificationComponent,
                        parameters_component_1.ParametersComponent,
                        progressbar_component_1.ProgressbarComponent,
                        money_component_1.MoneyComponent,
                        radio_component_1.RadioComponent,
                        radio_option_component_1.RadioOptions,
                        relatorios_component_1.RelatoriosComponent,
                        report_component_1.ReportComponent,
                        rotator_component_1.RotatorComponent,
                        row_component_1.RowComponent,
                        select_component_1.SelectComponent,
                        tab_component_1.TabComponent,
                        tabs_component_1.TabsComponent,
                        treeview_component_1.TreeviewComponent,
                        upload_component_1.UploadComponent,
                        upload_image_component_1.UploadImageComponent,
                        image_component_1.ImageComponent,
                        label_component_1.LabelComponent,
                        filter_pipe_1.SelectFilterPipe,
                        filter_pipe_1.FilterPipe,
                        drag_and_drop_component_1.DragAndDropComponent,
                        drag_component_1.DragComponent,
                        drop_component_1.DropComponent,
                        drag_drop_content_1.DragDropContentComponent,
                        pie_component_1.PieComponent,
                        bar_component_1.BarComponent,
                        line_component_1.LineComponent,
                        series_component_1.SeriesComponent,
                        translate_pipe_pipe_1.TranslatePipe,
                        safePipe_1.SafePipe,
                        cep_directive_1.CepDirective,
                        regexp_directive_1.RegExpDirective,
                        cpf_directive_1.CpfDirective,
                        phone_directive_1.PhoneDirective,
                        cnpj_directive_1.CnpjDirective,
                        calc_component_1.CalcComponent,
                        pdf_component_1.PdfComponent,
                        progress_component_1.ProgressComponent,
                        schedule_process_component_1.ScheduleProcessComponent,
                        schedule_times_component_1.ScheduleTimesComponent,
                        scheduling_component_1.SchedulingComponent,
                        mask_directive_1.MaskDirective,
                        max_directive_1.MaxDirective,
                        min_directive_1.MinDirective,
                        tooltip_directive_1.TooltipDirective,
                        mask_telefone_pipe_1.MaskTelefonePipe,
                        filter_pipe_1.MultiSelectFilterPipe,
                        filter_pipe_1.FilterAllPipe,
                        color_picker_component_1.ColorPickerComponent,
                        monitor_component_1.DialogReportInfoDialog,
                        pdf_component_1.PDFDialogComponent,
                        input_ip_component_1.InputIpComponent,
                        datetime_component_1.DatetimeComponent,
                        datetime_native_component_1.DatetimeNativeComponent,
                        numberfixedlen_pipe_1.NumberfixedlenPipe,
                        tab_generic_component_1.TabGenericComponent,
                        crud_container_component_1.CrudContainerComponent,
                        tabs_chrome_componente_1.TabsChromeComponent,
                        monitor_component_1.DialogError,
                        div_component_1.DivComponent,
                        crud_component_1.CrudActionButtonComponent,
                        entity_component_1.EntityComponent,
                        master_detail_component_1.DialogMasterDetail,
                        dialog_audit_component_1.DialogAuditDetail,
                        generic_key_component_1.GenericKeyComponent,
                        dialog_filter_component_1.DialogFilterDetail,
                        audit_component_1.AuditComponent,
                        master_detail_form_generic_1.MasterDetailFormGenericComponent,
                        tabs_error_component_1.TabsErrorComponent,
                        sidenav_component_1.SidenavComponent
                    ],
                    exports: [
                        input_text_component_1.InputTextComponent,
                        textarea_component_1.TextareaComponent,
                        input_cep_component_1.InputCepComponent,
                        input_cnpj_component_1.InputCnpjComponent,
                        input_cpf_component_1.InputCpfComponent,
                        input_email_component_1.InputEmailComponent,
                        input_mask_component_1.InputMaskComponent,
                        input_number_component_1.InputNumberComponent,
                        input_password_component_1.InputPasswordComponent,
                        input_telefone_component_1.InputTelefoneComponent,
                        editor_component_1.EditorComponent,
                        accordion_component_1.AccordionComponent,
                        accordion_group_component_1.AccordionGroupComponent,
                        alert_component_1.AlertComponent,
                        autocomplete_component_1.AutocompleteComponent,
                        breadcrumb_component_1.BreadcrumbComponent,
                        breadcrumb_crud_component_1.BreadcrumbCrudComponent,
                        button_component_1.ButtonComponent,
                        button_submit_component_1.ButtonSubmitComponent,
                        checkbox_component_1.CheckboxComponent,
                        bookmark_component_1.BookmarkComponent,
                        calc_button_component_1.CalcButtonComponent,
                        multiselect_dropdown_component_1.MultiselectDropdownComponent,
                        crud_component_1.CrudComponent,
                        grid_component_1.SbmGridColumn,
                        master_detail_component_1.MasterDetailComponent,
                        filters_component_1.FiltersComponent,
                        menu_component_1.SubMenuComponent,
                        monitor_component_1.MonitorComponent,
                        ng2_pdf_viewer_1.PdfViewerComponent,
                        datebox_component_1.DateboxComponent,
                        fieldset_component_1.FieldsetComponent,
                        form_component_1.FormComponent,
                        grid_component_1.GridComponent,
                        list_view_component_1.ListViewComponent,
                        list_option_component_1.ListOptions,
                        menu_component_1.MenuComponent,
                        menu_component_1.ItemMenuComponent,
                        modal_component_1.ModalComponent,
                        money_component_1.MoneyComponent,
                        multiselect_component_1.MultiselectComponent,
                        notification_component_1.NotificationComponent,
                        parameters_component_1.ParametersComponent,
                        progressbar_component_1.ProgressbarComponent,
                        radio_component_1.RadioComponent,
                        radio_option_component_1.RadioOptions,
                        relatorios_component_1.RelatoriosComponent,
                        report_component_1.ReportComponent,
                        rotator_component_1.RotatorComponent,
                        row_component_1.RowComponent,
                        select_component_1.SelectComponent,
                        tab_component_1.TabComponent,
                        tabs_component_1.TabsComponent,
                        treeview_component_1.TreeviewComponent,
                        upload_component_1.UploadComponent,
                        upload_image_component_1.UploadImageComponent,
                        image_component_1.ImageComponent,
                        label_component_1.LabelComponent,
                        filter_pipe_1.SelectFilterPipe,
                        filter_pipe_1.FilterPipe,
                        drag_and_drop_component_1.DragAndDropComponent,
                        drag_component_1.DragComponent,
                        drop_component_1.DropComponent,
                        drag_drop_content_1.DragDropContentComponent,
                        crud_component_1.CrudFormComponent,
                        pie_component_1.PieComponent,
                        bar_component_1.BarComponent,
                        series_component_1.SeriesComponent,
                        line_component_1.LineComponent,
                        translate_pipe_pipe_1.TranslatePipe,
                        safePipe_1.SafePipe,
                        cep_directive_1.CepDirective,
                        regexp_directive_1.RegExpDirective,
                        cpf_directive_1.CpfDirective,
                        phone_directive_1.PhoneDirective,
                        cnpj_directive_1.CnpjDirective,
                        calc_component_1.CalcComponent,
                        pdf_component_1.PdfComponent,
                        progress_component_1.ProgressComponent,
                        schedule_process_component_1.ScheduleProcessComponent,
                        schedule_times_component_1.ScheduleTimesComponent,
                        scheduling_component_1.SchedulingComponent,
                        mask_directive_1.MaskDirective,
                        max_directive_1.MaxDirective,
                        min_directive_1.MinDirective,
                        tooltip_directive_1.TooltipDirective,
                        mask_telefone_pipe_1.MaskTelefonePipe,
                        filter_pipe_1.FilterAllPipe,
                        filter_pipe_1.MultiSelectFilterPipe,
                        color_picker_component_1.ColorPickerComponent,
                        monitor_component_1.DialogReportInfoDialog,
                        pdf_component_1.PDFDialogComponent,
                        input_ip_component_1.InputIpComponent,
                        datetime_component_1.DatetimeComponent,
                        datetime_native_component_1.DatetimeNativeComponent,
                        tab_generic_component_1.TabGenericComponent,
                        tabs_chrome_componente_1.TabsChromeComponent,
                        monitor_component_1.DialogError,
                        div_component_1.DivComponent,
                        crud_component_1.CrudActionButtonComponent,
                        entity_component_1.EntityComponent,
                        master_detail_component_1.DialogMasterDetail,
                        ng2_toasty_1.ToastyModule,
                        ng2_slim_loading_bar_1.SlimLoadingBarModule,
                        dialog_filter_component_1.DialogFilterDetail,
                        master_detail_form_component_1.SbmMasterDetailForm,
                        dialog_audit_component_1.DialogAuditDetail,
                        audit_component_1.AuditComponent,
                        master_detail_form_generic_1.MasterDetailFormGenericComponent,
                        audit_component_1.AuditComponent,
                        tabs_error_component_1.TabsErrorComponent,
                        sidenav_component_1.SidenavComponent,
                        timeline_module_1.TimelineModule,
                    ],
                    schemas: [core_1.CUSTOM_ELEMENTS_SCHEMA, core_1.NO_ERRORS_SCHEMA],
                    entryComponents: [
                        form_component_1.FormComponent,
                        calc_component_1.CalcComponent,
                        tab_component_1.TabComponent,
                        monitor_component_1.DialogReportInfoDialog,
                        monitor_component_1.DialogError,
                        pdf_component_1.PDFDialogComponent,
                        tabs_component_1.TabsComponent,
                        master_detail_component_1.MasterDetailComponent,
                        master_detail_form_component_1.SbmMasterDetailForm,
                        tab_generic_component_1.TabGenericComponent,
                        master_detail_component_1.DialogMasterDetail,
                        crud_container_component_1.CrudContainerComponent,
                        dialog_audit_component_1.DialogAuditDetail,
                        dialog_filter_component_1.DialogFilterDetail,
                        master_detail_form_generic_1.MasterDetailFormGenericComponent,
                        tabs_error_component_1.TabsErrorComponent,
                        button_component_1.ButtonComponent
                    ],
                    providers: [
                        req_http_service_1.ReqHttpService, web_sql_service_1.WebSqlService, indexed_db_service_1.IndexedDBService, master_detail_form_component_1.SbmMasterDetailForm, sharedService_1.SharedService,
                        sbm_http_client_service_1.SbmHttpClientService, breadcrumb_service_1.BreadcrumbService, select_service_1.SelectService, tabs_error_service_1.TabsErrorService, filter_pipe_1.FilterAllPipe,
                        layout_1.MediaMatcher,
                        { provide: material_1.MAT_PLACEHOLDER_GLOBAL_OPTIONS, useValue: ɵ0 },
                        {
                            provide: http_2.HTTP_INTERCEPTORS,
                            useClass: InterceptorHttp_1.InterceptorHttp,
                            multi: true,
                        },
                        {
                            provide: platform_browser_1.HAMMER_GESTURE_CONFIG,
                            useClass: MyHammerConfig
                        }
                    ]
                },] },
    ];
    /** @nocollapse */
    SbmModule.ctorParameters = function () { return []; };
    return SbmModule;
}());
exports.SbmModule = SbmModule;
