import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
export declare class SbmHttpClientService {
    private http;
    constructor(http: HttpClient);
    changeUrl(url: string): string;
    get<T>(url: string, params?: any): Observable<T>;
    post<T>(url: string, body: any): Observable<T>;
    put<T>(url: string, body: any): Observable<T>;
    delete<T>(url: string, body: any): Observable<T>;
}
