"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var http_1 = require("@angular/http");
var tab_generic_component_1 = require("../components/tabs/tab-generic/tab-generic.component");
var SelectService = /** @class */ (function () {
    function SelectService(compiler, componentFactoryResolver, _http) {
        this.compiler = compiler;
        this.componentFactoryResolver = componentFactoryResolver;
        this._http = _http;
        this.modulesDinamic = [];
    }
    SelectService.prototype.actionClicked = function (select) {
        var _this = this;
        this.select = select;
        this._http.get('assets/pages/' + this.select.urlButton + '.html').subscribe(function (ret) {
            var factory = _this.componentFactoryResolver.resolveComponentFactory(tab_generic_component_1.TabGenericComponent);
            var injector = core_1.ReflectiveInjector.fromResolvedProviders([], _this.select._vcRef.parentInjector);
            var res = factory.create(injector);
            if (_this.modulesDinamic.length > 0) {
                res.instance.modules = res.instance.modules.concat(_this.modulesDinamic);
            }
            res.instance.compileTemplate(ret._body);
            res.changeDetectorRef.detectChanges();
            _this.select._vcRef.insert(res.hostView);
        });
    };
    SelectService.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    SelectService.ctorParameters = function () { return [
        { type: core_1.Compiler, },
        { type: core_1.ComponentFactoryResolver, },
        { type: http_1.Http, },
    ]; };
    return SelectService;
}());
exports.SelectService = SelectService;
